.........1.........2.........3.........4.........5.........6.........7.........8

[This is the complete assembler listing for Toni Baker's Light Screen Designer,]
[published in 13 parts in ZX Computing from June/July 1984 - June 1986. This   ]
[listing includes all corrections to printing and programming errors, both     ]
[those reported by the author and readers and those never reported in the      ]
[magazine but which I discovered myself while transcribing the text and        ]
[checking the program listings.                                                ]
[All comments in [] have been added by me.                                 JimG]

[Save: SAVE "LSD" CODE 56064,3863    ]
[Load: CLEAR 49151: LOAD "LSD" CODE  ]
[Run : RANDOMIZE USR 56789           ]
[The author said to save from DB00 (56064), although the code doesn't start    ]
[until DB42 (56130); the intervening space is used for program variables.      ]
[The area from C000 (49152) to DAFF is used for a copy of the screen.      JimG]

DB42 04E0     CMD_ADDRS DEFW E004,BORDERCOL (BORDER)
DB44 8FE0               DEFW E0F8,CALC_CENT (CIRCLE_CENTRE)
DB46 1BE7               DEFW E71B,Q_ELLIPSE (QUARTER_ELLIPSE)
DB48 0000               DEFW 0000,not used
DB4A 0000               DEFW 0000,not used
DB4C 29E2               DEFW E229,ARC_RAD   (DRAW_ARC_RAD)
DB4E 30E1               DEFW E130,CIRC_THRU (CIRCLE_THRU)
DB50 5DDF               DEFW DF5D,COLOURS   (FLASH)
DB52 5DDF               DEFW DF5D,COLOURS   (OVER)
DB54 3AE0               DEFW E03A,RECTANGLE
DB56 50E0               DEFW E050,PARALLGRM (PARALLELOGRAM)    [not 53E0]
DB58 0000               DEFW 0000,not used
DB5A 9BDF               DEFW DF9B,RECALL
DB5C A5E2               DEFW E2A5,ARC_USING (DRAW_ARC_USING)
DB5E 90E6               DEFW E690,ELLIPSE
DB60 5DDF               DEFW DF5D,COLOURS   (PAPER)
DB62 5DDF               DEFW DF5D,COLOURS   (INVERSE)
DB64 2AE0               DEFW E02A,TRIANGLE
DB66 80DF               DEFW DF80,CLEAR
DB68 0000               DEFW 0000,not used
DB6A 85DF               DEFW DF85,STORE
DB6C C5E2               DEFW E2C5,ARC_THRU  (DRAW_ARC_THRU)
DB6E 38DF               DEFW DF38,CANCEL_MK (CANCEL_MARK)
DB70 5DDF               DEFW DF5D,COLOURS   (INK)
DB72 5DDF               DEFW DF5D,COLOURS   (BRIGHT)
DB74 C2DF               DEFW DFC2,USR_CALL  (USR)
DB76 12EA               DEFW EA12,CURS_TYPE (CURSOR_TYPE)
DB78 B8DF               DEFW DFB8,CLEAR_SCR (CLS)
DB7A 7EE8               DEFW E87E,FILL                         [not 7AE8]
DB7C 04DF               DEFW DF04,DRAW_LINE
DB7E 30DF               DEFW DF30,MARK
DB80 0FE0               DEFW E00F,COPY_SCRN (COPY)
DB82 9EDE               DEFW DE9E,ESCAPE
DB84 28DF               DEFW DF28,HIDE
DB86 61E5               DEFW E561,TEXT_MODE (TEXT)
DB88 BEDE               DEFW DEBE,UNDO
DB8A 74E8               DEFW E874,PAINT                        [not 70E8]
DB8C FBDE               DEFW DEFB,PLOT
DB8E F3DE               DEFW DEF3,MOVE

DB90 59CE3831 INP_TABLE DEFM "Y","N*","8","1"
DB94 B00D3938           DEFM "0*","enter","9","8"
DB98 37363534           DEFM "7","6","5","4"
DB9C 333231B0           DEFM "3","2","1","0*"

DBA0          MES_TABLE DEFM "Light Screen Designer",80
DBB6                    DEFM "Paint Colour",98
DBC3                    DEFM "WARNING - Screen Memory Wipe",90
DBE0                    DEFM "Store Memory",95
DBED                    DEFM "Recall Memory",95
DBFB                    DEFM "Clear Screen",90
DC08                    DEFM "Number of Radians?",80
DC1C                    DEFM "Now in Text Mode",80
DC2D                    DEFM "Machine Code Address?",80
DC44                    DEFM "Copy",90
DC49                    DEFM "Ink Colour",96
DC54                    DEFM "Paper Colour",96
DC61                    DEFM "Flash Status",92
DC6E                    DEFM "Border Colour",98
DC7C                    DEFM "Over Status",9E
DC88                    DEFM "Inverse Status",9E
DC97                    DEFM "Bright Status",92
DCA5                    DEFM "Return to BASIC",90

DCB5 CD8E02   GET_CHR   CALL KEY_SCAN      ;DE= keyboard scan
DCB8 7B                 LD   A,E
DCB9 FE27               CP   #27
DCBB 2803               JR   Z,GET_CHR_2   ;Jump if "caps shift" only pressed
DCBD 3C                 INC  A
DCBE 20F5               JR   NZ,GET_CHR    ;Jump unless no keys at
                                           ;all are pressed
DCC0 CD8E02   GET_CHR_2 CALL KEY_SCAN      ;DE= keyboard scan
DCC3 7B                 LD   A,E
DCC4 FE27               CP   #27
DCC6 28F8               JR   Z,GET_CHR_2   ;Jump if "caps shift" only pressed
DCC8 3C                 INC  A
DCC9 28F5               JR   Z,GET_CHR_2   ;Jump if no keys at
                                           ;all are pressed
DCCB C9                 RET

DCCC AF       MESSAGE   XOR  A             ;A= 00
DCCD CD0116             CALL CHAN_OPEN     ;Use stream number zero
                                           ;(lower part of screen)
DCD0 E1                 POP  HL            ;HL= address of data byte
DCD1 46                 LD   B,(HL)        ;B= number of message to print
DCD2 23                 INC  HL            ;HL= subroutine return address
DCD3 E5                 PUSH HL
DCD4 219FDB             LD   HL,MESSAGES-1
DCD7 7E       ME_SEARCH LD   A,(HL)
DCD8 23                 INC  HL
DCD9 FE80               CP   #80
DCDB 38FA               JR   C,ME_SEARCH   ;Find start of next message
DCDD 10F8               DJNZ ME_SEARCH     ;Search to find appropriate message
DCDF 7E       ME_PRINT  LD   A,(HL)        ;A= next character of message
DCE0 23                 INC  HL
DCE1 FE80               CP   #80
DCE3 C8                 RET  Z             ;Return if data byte 80 found
DCE4 3003               JR   NC,ME_INPUT   ;Jump if other data byte found
DCE6 D7                 RST  #10           ;Print character
DCE7 18F6               JR   ME_PRINT
DCE9 6F       ME_INPUT  LD   L,A
DCEA 26DB               LD   H,INP_TABLE hi;HL points to allowed inputs
DCEC 3E3F               LD   A,"?"
DCEE D7                 RST  #10           ;Print a question mark
DCEF E5       ME_I_LOOP PUSH HL
DCF0 CDB5DC             CALL GET_CHR       ;Wait for key to be pressed
DCF3 CD1E03             CALL K_TEST        ;Convert to character code
DCF6 E1                 POP  HL
DCF7 FE20               CP   #20
DCF9 2811               JR   Z,ME_EXIT     ;Jump if "ESCAPE" pressed
                                           ;(Note that the stack is
                                           ;deliberately unbalanced)
DCFB E5                 PUSH HL
DCFC 4F                 LD   C,A           ;C= character just input
DCFD 7E       ME_CHECK  LD   A,(HL)        ;A= one of the allowed characters
DCFE 23                 INC  HL
DCFF 47                 LD   B,A
DD00 E67F               AND  #7F           ;Disregard bit 7
DD02 B9                 CP   C
DD03 2807               JR   Z,ME_EXIT     ;Jump if allowed character was input
DD05 CB10               RL   B
DD07 30F4               JR   NC,ME_CHECK   ;Jump if there are more
                                           ;characters to check
DD09 E1                 POP  HL
DD0A 18E3               JR   ME_I_LOOP     ;Try again
DD0C E1       ME_EXIT   POP  HL            ;Balance the stack
DD0D F5                 PUSH AF
DD0E CD6E0D             CALL CLS_LOWER
DD11 F1                 POP  AF
DD12 C9                 RET

;Left Pix
DD13 79       LEFT_PIX  LD   A,C           ;A= column number
DD14 A7                 AND  A
DD15 37                 SCF
DD16 C8                 RET  Z             ;Return with carry set if at left
                                           ;margin
DD17 0D                 DEC  C             ;Decrement column number
DD18 79                 LD   A,C           ;A= new column number
DD19 F6F8               OR   #F8           ;Isolate bits 2, 1 and 0
DD1B 3C                 INC  A
DD1C C0                 RET  NZ            ;Return unless we have moved
                                           ;across two squares
DD1D 2D                 DEC  L             ;Amend print position
DD1E C9                 RET

;Right Pix
DD1F 79       RIGHT_PIX LD   A,C           ;A= column number
DD20 3C                 INC  A
DD21 37                 SCF
DD22 C8                 RET  Z             ;Return with carry set if at right
                                           ;margin
DD23 4F                 LD   C,A           ;Column number incremented
DD24 E607               AND  #07           ;Isolate bits 2, 1 and 0
DD26 C0                 RET  NZ            ;Return unless we have moved
                                           ;across two squares
DD27 2C                 INC  L             ;Amend print position
DD28 C9                 RET

;Up Pix
DD29 78       UP_PIX    LD   A,B           ;B= row number
DD2A A7                 AND  A
DD2B 37                 SCF
DD2C C8                 RET  Z             ;Return with carry set if at top
                                           ;margin
DD2D 05                 DEC  B             ;Decrement row number
DD2E 25                 DEC  H             ;Amend print position
DD2F 78                 LD   A,B           ;A= new row number
DD30 F6F8               OR   #F8           ;Isolate bits 2, 1 and 0
DD32 3C                 INC  A
DD33 280C               JR   Z,PIX_ADDR    ;Jump if we have moved across
                                           ;two squares
DD35 C9                 RET

;Down Pix
DD36 78       DOWN_PIX  LD   A,B           ;A= row number
DD37 3C                 INC  A
DD38 FEB0               CP   #B0
DD3A 37                 SCF
DD3B C8                 RET  Z             ;Return with carry set if at bottom
                                           ;margin
DD3C 47                 LD   B,A           ;Row number incremented
DD3D 24                 INC  H             ;Amend print position
DD3E E607               AND  #07           ;Isolate bits 2, 1 and 0
DD40 C0                 RET  NZ            ;Return unless we have moved
                                           ;across two squares

;Pix Addr
DD41 79       PIX_ADDR  LD   A,C           ;A= column number
DD42 07                 RLCA               ;Move bits 7-3 to positions
DD43 07                 RLCA               ;2, 1, 0, 7 and 6
DD44 07                 RLCA
DD45 A8                 XOR  B
DD46 E6C7               AND  #C7
DD48 A8                 XOR  B             ;Take bits 5, 4 and 3 from B
DD49 07                 RLCA
DD4A 07                 RLCA               ;Move all bits into final position
DD4B 6F                 LD   L,A           ;Assign low part of print position
DD4C 78                 LD   A,B           ;A= row number
DD4D 0F                 RRCA
DD4E 0F                 RRCA               ;Move bits 7 and 6 to positions
DD4F 0F                 RRCA               ;4 and 3
DD50 E618               AND  #18           ;Isolate these bits
DD52 FE18               CP   #18
DD54 C8                 RET  Z             ;Return if both bits are set
DD55 F640               OR   #40           ;Assign bits 7, 6 and 5
DD57 A8                 XOR  B
DD58 E6F8               AND  #F8
DD5A A8                 XOR  B             ;Take bits 2, 1 and 0 from B
DD5B 67                 LD   H,A           ;Assign high part of print position
DD5C C9                 RET

;Plot Over subroutine
DD5D C5       PLOT_PIX  PUSH BC
DD5E 79                 LD   A,C           ;A= column number
DD5F E607               AND  #07           ;A= pixel number within square
DD61 47                 LD   B,A
DD62 04                 INC  B             ;B= position within row segment
                                           ;of pixel to alter
DD63 3E01               LD   A,#01
DD65 0F       PPX_LOOP  RRCA
DD66 10FD               DJNZ PPX_LOOP      ;Move set bit into position
DD68 AE                 XOR  (HL)
DD69 77                 LD   (HL),A        ;Alter designated bit
DD6A C1                 POP  BC
DD6B C9                 RET

;Draw Cursor subroutine
DD6C DDCB017E DR_CURSOR BIT  7,(JFLAGS) hi
DD70 C0                 RET  NZ            ;Return if cursor not required
DD71 CD5DDD             CALL PLOT_PIX      ;Plot centre of cursor
DD74 DDCB0176           BIT  6,(JFLAGS) hi
DD78 C0                 RET  NZ            ;Return if crosswires not required
DD79 1113DD             LD   DE,LEFT_PIX
DD7C CD8BDD             CALL DR_ARM        ;Draw left arm of crosswires
DD7F 1E1F               LD   E,RIGHT_PIX lo
DD81 CD8BDD             CALL DR_ARM        ;Draw right arm of crosswires
DD84 1E29               LD   E,DOWN_PIX lo 
DD86 CD8BDD             CALL DR_ARM        ;Draw lower arm of crosswires
DD89 1E36               LD   E,UP_PIX lo
DD8B C5       DR_ARM    PUSH BC
DD8C E5                 PUSH HL
DD8D 3E04               LD   A,#04         ;A determines size of crosswires
DD8F 08       DRA_LOOP  EX   AF,AF'        ;A' stores loop count
DD90 E5                 PUSH HL
DD91 2197DD             LD   HL,DRA_RET
DD94 E3                 EX   (SP),HL       ;Push address DRA_RET on stack
DD95 D5                 PUSH DE
DD96 C9                 RET                ;Call subroutine at address DE
DD97 3807     DRA_RET   JR   C,DRA_EXIT    ;Exit loop if margin reached
DD99 CD5DDD             CALL PLOT_PIX      ;Plot next pixel of arm
DD9C 08                 EX   AF,AF'
DD9D 3D                 DEC  A
DD9E 20EF               JR   NZ,DRA_LOOP   ;Repeat until whole arm drawn
DDA0 E1       DRA_EXIT  POP  HL
DDA1 C1                 POP  BC
DDA2 C9                 RET

;Cursor Initialisation subroutine
DDA3 34       RESCURSOR INC  (HL)          ;Is byte four FF?
DDA4 200E               JR   NZ,RC_EXIT    ;Jump if not, restoring value of byte
DDA6 2B                 DEC  HL
DDA7 2B                 DEC  HL
DDA8 2B                 DEC  HL            ;Point to byte one
DDA9 3600               LD   (HL),#00
DDAB 23                 INC  HL
DDAC 3640               LD   (HL),#40      ;Specify cursor address 4000h
                                           ;(top left-hand corner of screen)
DDAE 23                 INC  HL
DDAF 3600               LD   (HL),#00      ;Specify column number zero
DDB1 23                 INC  HL
DDB2 3601               LD   (HL),#01      ;Specify row number zero
                                           ;(because of next instruction)
DDB4 35       RC_EXIT   DEC  (HL)
DDB5 C9                 RET

;Routine to draw each of the three cursors: ORIGIN, MARKER and CURSOR
DDB6 D5       DRCURSORS PUSH DE
DDB7 210CDB             LD   HL,ORIGIN     ;HL contains address of program
                                           ;variable named ORIGIN
DDBA 0603               LD   B,#03
DDBC C5       DCS_LOOP  PUSH BC
DDBD 5E                 LD   E,(HL)
DDBE 23                 INC  HL
DDBF 56                 LD   D,(HL)        ;DE= address of cursor within
                                           ;display file
DDC0 23                 INC  HL
DDC1 4E                 LD   C,(HL)        ;C= column number of cursor position
DDC2 23                 INC  HL
DDC3 46                 LD   B,(HL)        ;B= row number of cursor position
DDC4 23                 INC  HL            ;Point HL to next variable
DDC5 78                 LD   A,B           ;A= row number, or FF if cursor not
                                           ;in use
DDC6 FEFF               CP   #FF
DDC8 2806               JR   Z,DCS_CONT    ;Jump if cursor not in use
DDCA E5                 PUSH HL
DDCB EB                 EX   DE,HL         ;HL= address of cursor
DDCC CD6CDD             CALL DR_CURSOR     ;Draw specified cursor
DDCF E1                 POP  HL            ;HL points to next variable
DDD0 C1       DCS_CONT  POP  BC            ;B = loop count
DDD1 10E9               DJNZ DCS_LOOP
DDD3 D1                 POP  DE            ;Leave original DE unaltered
DDD4 C9                 RET

;Complete program initialisation subroutine
DDD5 CDCCDC   START     CALL MESSAGE
DDD8 01                 DEFB 01            ;Print messg "Light Screen Designer"
DDD9 CDBF16             CALL SET_WORK      ;Maximise spare RAM space
DDDC 2100DB             LD   HL,ORIGIN2    ;Point HL to first program variable
DDDF 0610               LD   B,#10
DDE1 C5       LSD_LOOP  PUSH BC
DDE2 5E                 LD   E,(HL)
DDE3 23                 INC  HL
DDE4 56                 LD   D,(HL)        ;DE= address of cursor, if assigned
DDE5 23                 INC  HL
DDE6 4E                 LD   C,(HL)        ;C= col number of cursor, if assigned
DDE7 23                 INC  HL
DDE8 46                 LD   B,(HL)        ;B= row number of cursor, if assigned
DDE9 78                 LD   A,B
DDEA FEB0               CP   #B0
DDEC 300A               JR   NC,LSD_RESET  ;Jump if row number out of range
DDEE E5                 PUSH HL
DDEF CD41DD             CALL PIX_ADDR      ;and column numbers
DDF2 A7                 AND  A
DDF3 ED52               SBC  HL,DE         ;Set zero flag if this address
                                           ;matches to the one given
DDF5 E1                 POP  HL            ;HL points to byte four of program
                                           ;variable
DDF6 2802               JR   Z,LSD_OK      ;Jump if cursor position is already
                                           ;assigned
DDF8 36FF     LSD_RESET LD   (HL),#FF      ;Signal "cursor not in use"
DDFA 23       LSD_OK    INC  HL            ;Point to byte one of next program
                                           ;variable
DDFB C1                 POP  BC
DDFC 10E3               DJNZ LSD_LOOP      ;Repeat for all cursors
DDFE 70                 LD   (HL),B
DDFF 23                 INC  HL
DE00 70                 LD   (HL),B        ;Reset (JFLAGS)
DE01 210FDB             LD   HL,ORIGIIN+3  ;HL points to byte four of (ORIGIN)
DE04 CDA3DD             CALL RESCURSOR     ;Reset origin-cursor to 0,0
                                           ;if not in use
DE07 2E17               LD   L,#17
DE09 CDA3DD             CALL RESCURSOR     ;Reset main-cursor to 0,0
                                           ;if not in use
DE0C CD8E02   LSD_READY CALL KEY_SCAN      ;DE= immediate keyboard scan
DE0F 7B                 LD   A,E           ;A= key code ignoring shift
DE10 FE20               CP   #20
DE12 20F8               JR   NZ,LSD_READY  ;Wait until "ESCAPE" key pressed
DE14 CD6E0D             CALL CALL CLS_LOWER     ;Clear lower part of screen
                                           ;to erase message

DE17 DD2140DB MAIN_LOOP LD   IX,#DB40      ;Initialise IX as required
DE1B CDB6DD             CALL DRCURSORS     ;Draw all required cursors
DE1E CDB5DC             CALL GET_CHR       ;Wait for key press
DE21 CDB6DD   MAINLOOP2 CALL DRCURSORS     ;"Undraw" the cursors
DE24 2A14DB             LD   HL,(CURSOR)
DE27 ED4B16DB           LD   BC,(CURSOR+2)
DE2B D5                 PUSH DE            ;Stack the key scan
DE2C 7B                 LD   A,E           ;A= key code
DE2D FE03               CP   #03
DE2F 284D               JR   Z,CSR_DOWN    ;Jump if "cursor down" pressed
DE31 FE04               CP   #04
DE33 283A               JR   Z,CSR_LEFT    ;Jump if "cursor left" pressed
DE35 FE0B               CP   #0B
DE37 2840               JR   Z,CSR_UP      ;Jump if "cursor up" pressed
DE39 FE13               CP   #13
DE3B 2837               JR   Z,CSR_RIGHT   ;Jump if "cursor right" pressed
DE3D 21ADDE   ML_TEST   LD   HL,#DEAD      ;NULL_TABLE
DE40 011100             LD   BC,#0011
DE43 EDB1               CPIR               ;Is key pressed in null table?
DE45 280A               JR   Z,ML_ACTION   ;Jump if so
DE47 2141DB             LD   HL,JFLAGS hi
DE4A CB66               BIT  4,(HL)
DE4C CCC9DE             CALL Z,COPY_SCRN   ;Copy screen if allowed
DE4F CBAE               RES  5,(HL)
DE51 D1       ML_ACTION POP  DE            ;DE= keyboard scan
DE52 2117DE             LD   HL,MAIN_LOOP
DE55 E5                 PUSH HL            ;Force subroutine return address
                                           ;to be MAIN_LOOP
DE56 2142DB             LD   HL,CMD_ADDRS
DE59 14                 INC  D
DE5A 2803               JR   Z,ML_CASE     ;Jump unless "Shift" pressed
DE5C E1                 POP  HL            ;Drop MAIN_LOOP address
DE5D 1839               JR   RET_BASIC     ;Prepare to return to BASIC
DE5F 7B       ML_CASE   LD   A,E           ;A= key code
DE60 87                 ADD  A,A
DE61 85                 ADD  A,L
DE62 6F                 LD   L,A           ;HL points to subroutine address
DE63 4E                 LD   C,(HL)
DE64 23                 INC  HL
DE65 46                 LD   B,(HL)        ;BC= subroutine address
DE66 C5                 PUSH BC
DE67 2A14DB             LD   HL,(CURSOR)
DE6A ED4B16DB           LD   BC,(CURSOR+2)
DE6E C9                 RET                ;Jump to required subroutine
DE6F CD13DD   CSR_LEFT  CALL LEFT_PIX      ;Move cursor left
DE72 180D               JR   CSR_STORE
DE74 CD1FDD   CSR_RIGHT CALL RIGHT_PIX     ;Move cursor right
DE77 1808               JR   CSR_STORE
DE79 CD29DD   CSR_UP    CALL UP_PIX        ;Move cursor up
DE7C 1803               JR   CSR_STORE
DE7E CD36DD   CSR_DOWN  CALL DOWN_PIX      ;Move cursor down
DE81 3807     CSR_STORE JR   C,CSR_EXIT    ;Jump if cursor cannot move
DE83 2214DB             LD   (CURSOR),HL
DE86 ED4316DB           LD   (CURSOR+2),BC
DE8A D1       CSR_EXIT  POP  DE            ;DE= keyboard scan
DE8B 14                 INC  D
DE8C 288D               JR   Z,MAIN_LOOP   ;Loop back unless "Shift" pressed
DE8E CDB6DD             CALL DRCURSORS     ;Redraw the cursors
DE91 76                 HALT
DE92 76                 HALT               ;Wait for 1/25th of a second
DE93 CDC0DC             CALL GET_CHR_2     ;DE= keyboard scan
DE96 1889               JR   MAINLOOP2     ;Loop back

DE98 CD9EDE   RET_BASIC CALL ESCAPE
DE9B C31BDE             JP   MAIN_LOOP
DE9E CDCCDC   ESCAPE    CALL MESSAGE
DEA1 12                 DEFB #12           ;Print message and await reply
DEA2 FE59               CP   "Y"
DEA4 C0                 RET  NZ            ;Return unless reply was "Y"
DEA5 D9                 EXX
DEA6 E1                 POP  HL            ;Drop return address to empty stack
DEA7 215827             LD   HL,#2758
DEAA D9                 EXX                ;HL'=2758 to ensure return to BASIC
DEAB C9                 RET                ;Return to BASIC
DEAC 00       ESC_BYTE  DEFB #00           ;Byte unused as yet

DEAD 0007080C NULLTABLE "BORDER","FLASH","OVER","RECALL"
DEB1 0F101214           "PAPER","INVERSE","CLEAR","STORE",
DEB5 1617181A           "CANCEL_MARK","INK","BRIGHT","CURSOR_TYPE"
DEB9 1E202123           "MARK","ESCAPE","HIDE","UNDO"
DEBD 26                 "MOVE"

;COPY SCREEN subroutine
DEBE DDCB0166 UNDO      BIT  4,(JFLAGS) hi
DEC2 C0                 RET  NZ            ;Return if the memory is being used
                                           ;for some other purpose
DEC3 DDCB016E           BIT  5,(JFLAGS) hi
DEC7 C0                 RET  NZ            ;Return if screen copy has been
                                           ;corrupted
DEC8 A7                 AND  A             ;Reset the zero flag
DEC9 E5       COPY_SCRN PUSH HL
DECA 210040             LD   HL,D_FILE     ;HL points to start of screen
DECD 1100C0             LD   DE,D_FILE_COPY;DE points to start of copy
DED0 01001B             LD   BC,#1B00      ;BC length of screen memory
DED3 2801               JR   Z,CSC_1       ;Jump if making copy of screen
DED5 EB                 EX   DE,HL
DED6 EDB0     CSC_1     LDIR               ;Make required copy
DED8 210CDB             LD   HL,ORIGIN     ;HL points to cursor info
DEDB 1100DB             LD   DE,ORIGIN_COPY;DE points to duplicate cursor info
DEDE 4D                 LD   C,L           ;BC 000C = length of info memory
DEDF 2801               JR   Z,CSC_2       ;Jump if making copy of screen
DEE1 EB                 EX   DE,HL
DEE2 EDB0     CSC_2     LDIR               ;Make required copy
DEE4 E1                 POP  HL
DEE5 C9                 RET

;Routine to prepare B and D registers for the ROM's PLOT routine
DEE6 3EAF     ADJUST_BD LD   A,#AF
DEE8 92                 SUB  D             ;A= adjusted coordinate
DEE9 57                 LD   D,A           ;D now adjusted
DEEA 3EAF     ADJUST_B  LD   A,#AF
DEEC 90                 SUB  B             ;A= adjusted coordinate
DEED 47                 LD   B,A           ;B now adjusted
DEEE C9                 RET

;Move procedure
DEEF ED5B0EDB MOVE_X    LD   DE,(ORIGIN+2) ;DE pixel position of origin-cursor
                                           ;prior to move
DEF3 220CDB   MOVE      LD   (ORIGIN),HL   ;Change origin-cursor (address)
DEF6 ED430EDB           LD   (ORIGIN+2),BC ;Change origin-cursor (pixel pos)
DEFA C9                 RET

;PLOT procedure
DEFB CDF3DE   PLOT      CALL MOVE          ;Move origin-cursor to new position
DEFE CDEADE             CALL ADJUST_B      ;Adjust the B register ready to PLOT
DF01 C3E522   J_PLOT    JP   PLOT_SUB      ;Plot the point

;The DRAW_LINE procedure
DF04 CDEFDE   DRAW_LINE CALL MOVE_X        ;Move origin cursor to new position
DF07 CDE6DE             CALL ADJUST_BD     ;Adjust B and D to ROM convention
DF0A C5                 PUSH BC            ;Stack cursor coordinates
DF0B EB                 EX   DE,HL         ;HL= previous coordinates
DF0C 227D5C             LD   (COORDS),HL   ;Store as "last point plotted"
DF0F 110101             LD   DE,#0101
DF12 78                 LD   A,B           ;A= y coord of cursor
DF13 94                 SUB  H             ;A= vertical DRAW parameter
DF14 3003               JR   NC,DL_1       ;Jump if positive or zero
DF16 2F                 CPL                ;A= ABS(vertical parameter)
DF17 16FF               LD   D,#FF         ;D indicates that vertical
                                           ;parameter is negative
DF19 47       DL_1      LD   B,A
DF1A 79                 LD   A,C           ;A= x coord of cursor
DF1B 95                 SUB  L             ;A= horizontal DRAW parameter
DF1C 3003               JR   NC,DL_2       ;Jump if positive or zero
DF1E 2F                 CPL                ;A= ABS(horizontal parameter)
DF1F 1EFF               LD   E,#FF         ;E indicates that horizontal
                                           ;parameter is negative
DF21 4F       DL_2      LD   C,A
DF22 CDBA24             CALL DRAW_3        ;Draw the line
DF25 C1                 POP  BC            ;BC= cursor coordinates
DF26 18D9               JR   J_PLOT        ;Jump to plot last point
DF28 3E80     HIDE      LD   A,#80         ;A has bit 7 set
DF2A 2141DB   CT_H      LD   HL,JFLAGS hi
DF2D AE                 XOR  (HL)
DF2E 77                 LD   (HL),A        ;Complement the required flag
DF2F C9                 RET

;These two routines place/remove the MARK cursor to/from the main cursor pos
DF30 2210DB   MARK      LD   (MARKER),HL
DF33 ED4312DB           LD   (MARKER+2),BC ;Move marker cursor
DF37 C9                 RET
DF38 2113DB   CANCEL_MK LD   HL,MARKER+3
DF3B 36FF               LD   (HL),#FF      ;Signal "marker cursor not in use"
DF3D C9                 RET

DF3E 010400   LOCATE    LD   BC,#0004      ;BC= number of bytes per memory
DF41 1114DB             LD   DE,CURSOR     ;DE points to cursor address
DF44 87                 ADD  A,A
DF45 87                 ADD  A,A
DF46 C658               ADD  A,#58
DF48 6F                 LD   L,A
DF49 62                 LD   H,D           ;HL point to required memory
DF4A C9                 RET

DF4B 500D12   COL_TABLE DEFB #50,#0D,#12   ;Information concerning FLASH
DF4E 520F15             DEFB #52,#0F,#15   ;Information concerning OVER
DF51 600C11             DEFB #60,#0C,#11   ;Information concerning PAPER
DF54 621014             DEFB #62,#10,#14   ;Information concerning INVERSE
DF57 700B10             DEFB #70,#0B,#10   ;Information concerning INK
DF5A 721113             DEFB #72,#11,#13   ;Information concerning BRIGHT

DF5D 214BDF   COLOURS   LD   HL,COL_TABLE  ;HL points to colour info table
DF60 45                 LD   B,L           ;BC= large number
DF61 EDB1               CPIR               ;Locate required entry to table
                                           ;(note that A contains low part of
                                           ;pointer into address table)
DF63 116FDF             LD   DE,COL_MES
DF66 EDA0               LDI                ;Alter program to print reqd message
DF68 1E77               LD   E,COL_CTR lo
DF6A EDA0               LDI                ;Alter program to select appropriate
                                           ;function
DF6C CDCCDC             CALL MESSAGE
DF6F 00       COL_MES   DEFS 01            ;Print required message
DF70 F5                 PUSH AF            ;Stack user's response
DF71 3E02               LD   A,#02
DF73 CD0116             CALL CHAN_OPEN     ;Select stream 2 (the screen)
DF76 3E00               LD   A,??          ;A= required control character
              COL_CTR   $-1
DF78 D7                 RST  #10           ;Print control code
DF79 F1                 POP  AF            ;A= user's response
DF7A D630               SUB  #30           ;A= required colour
DF7C D7                 RST  #10           ;Select required colour
DF7D C3AD1C             JP   PERMS+23      ;Make colour permanent

DF80 DDCB01A6 CLEAR     RES  4,(JFLAGS) hi ;Free memory for use by UNDO
DF84 C9                 RET
DF85 CDCCDC   STORE     CALL MESSAGE
DF88 04                 DEFB #04           ;Print message "Store memory"
DF89 FE0D               CP   "enter"
DF8B 2807               JR   Z,ST_SCR      ;Jump if "enter" pressed
DF8D CD3EDF             CALL LOCATE        ;Locate required memory
DF90 EB                 EX   DE,HL
DF91 EDB0               LDIR               ;Store cursor position
DF93 C9                 RET
DF94 DDCB01E6 ST_SCR    SET  4,(JFLAGS) hi ;Signal "memory is being used"
DF98 C3C9DE   S/R_SCR   JP   COPY_SCRN     ;Store screen (note Z flag is set)
DF9B CDCCDC   RECALL    CALL MESSAGE
DF9E 05                 DEFB #05           ;Print message "Recall memory"
DF9F FE0D               CP   "enter"
DFA1 280E               JR   Z,REC_SCR     ;Jump if "enter" pressed
DFA3 CD3EDF             CALL LOCATE        ;Locate required memory
DFA6 E5                 PUSH HL            ;Stack memory address
DFA7 09                 ADD  HL,BC         ;Point to next memory
DFA8 2B                 DEC  HL            ;Point to last byte of current memory
DFA9 7E                 LD   A,(HL)        ;A= last byte of memory
DFAA E1                 POP  HL            ;HL points to required memory
DFAB FEB0               CP   #B0
DFAD D0                 RET  NC            ;Return if memory not in use
DFAE EDB0               LDIR               ;Recall memory
DFB0 C9                 RET
DFB1 DDCB0166 REC_SCR   BIT  4,(JFLAGS) hi
DFB5 20E1               JR   NZ,S/R_SCR    ;Recall screen if memory in use
DFB7 C9                 RET

DFB8 CDCCDC   CLEAR_SCR CALL MESSAGE
DFBB 06                 DEFB #06           ;Print message "Clear screen?"
DFBC FE59               CP   "Y"
DFBE CA6B0D             JP   Z,CLS         ;Clear screen if required
DFC1 C9                 RET

DFC2 CDCCDC   USR_CALL  CALL MESSAGE
DFC5 09                 DEFB #09           ;Print messg "Machine code address?"
DFC6 210100             LD   HL,#0001
DFC9 E5       USR_LOOP  PUSH HL
DFCA FDCB30DE USR_KEY   SET  3,(FLAGS2)    ;Engage CAPS LOCK
DFCE CDDE15             CALL WAIT_KEY1     ;Wait for key to be pressed
DFD1 FE20               CP   #20
DFD3 282C               JR   Z,USR_ESC     ;Jump if ESCAPE pressed
DFD5 CD882C             CALL ALPHANUM
DFD8 30F0               JR   NC,USR_KEY    ;Jump unless letter or digit pressed
DFDA FE47               CP   "G"
DFDC 30EC               JR   NC,USR_KEY    ;Jump if "G" to "Z" pressed
DFDE F5                 PUSH AF
DFDF D7                 RST  #10           ;Print hex digit
DFE0 F1                 POP  AF
DFE1 D630               SUB  #30           ;Codes "0" to "9" now correct
DFE3 FE0A               CP   #0A
DFE5 3802               JR   C,USR_C       ;Jump if digit "0" to "9"
DFE7 D607               SUB  #07           ;Codes "A" to "F" now correct

DFE9 E1       USR_C     POP  HL            ;HL= "address so far"
DFEA 29                 ADD  HL,HL
DFEB 29                 ADD  HL,HL
DFEC 29                 ADD  HL,HL
DFED 29                 ADD  HL,HL         ;Shift HL one digit left
DFEE F5                 PUSH AF            ;Stack the carry flag
DFEF B5                 OR   L
DFF0 6F                 LD   L,A           ;Incorporate new digit
DFF1 F1                 POP  AF            ;Restore carry flag
DFF2 30D5               JR   NC,USR_LOOP   ;Loop back until digits collected
DFF4 E5                 PUSH HL            ;Stack m/code subroutine address
DFF5 CDDE15   USR_ENTER CALL WAIT_KEY1     ;Wait for key to be pressed
DFF8 FE20               CP   #20
DFFA 2805               JR   Z,USR_ESC     ;Jump if ESCAPE pressed
DFFC FE0D               CP   "enter"
DFFE 20F5               JR   NZ,USE_ENTER  ;Jump back unless "enter" pressed
E000 E5                 PUSH HL            ;Place dummy entry on stack
E001 E1       USR_ESC   POP  HL            ;Delete item from stack (either
                                           ;dummy entry or m/code address)
E002 1815               JR   UBC_LOWER     ;Jump to erase message from lower
                                           ;part of screen

E004 CDCCDC   BORDERCOL CALL MESSAGE
E007 0E                 DEFB #0E           ;Print message "Border colour?"
E008 D630               SUB  #30           ;A= required border colour
E00A CD9722             CALL BORDER+3      ;Change border colour
E00D 180A               JR   UBC_LOWER     ;Jump to change colour of bottom
                                           ;two lines of screen
E00F CDCCDC   COPY_SCRN CALL MESSAGE
E012 0A                 DEFB #0A           ;Print message "Copy?"
E013 FE59               CP   "Y"
E015 C0                 RET  NZ            ;Return if reply was "N"
E016 CDAC0E             CALL COPY          ;Copy screen onto printer
E019 C36E0D   UBC_LOWER JP   CLS_LOWER     ;Reset lower part of screen

E01C CD41DD   DRAW_2_BC CALL PIX_ADDR      ;HL= pixel address
E01F C304DF             JP   DRAW_LINE     ;Jump to draw line
E022 E1       TEST_MRKR POP  HL            ;HL= address of next instruction
E023 3A13DB             LD   A,(MARKER+3)
E026 FEB0               CP   #B0
E028 D0                 RET  NC            ;Return if marker unused
E029 E9                 JP   (HL)          ;Otherwise continue from next
                                           ;instruction
E02A CD22E0   TRIANGLE  CALL TEST_MRKR     ;Return if marker not in use
E02D ED5B0EDB           LD   DE,(ORIGIN+2) ;DE= origin cursor coordinates
E031 C5                 PUSH BC            ;Stack main cursor coordinates
E032 D5                 PUSH DE
E033 C5                 PUSH BC
E034 ED4B12DB           LD   BC,(MARKER+2) ;BC= marker coordinates
E038 1845               JR   PAR_3         ;Jump to draw three lines

E03A C5       RECTANGLE PUSH BC            ;Stack main cursor coordinates
E03B ED5B0EDB           LD   DE,(ORIGIN+2) ;DE= origin coordinates
E03F D5                 PUSH DE
E040 C5                 PUSH BC
E041 42                 LD   B,D
E042 CD1CE0             CALL DRAW_2_BC     ;Draw first line
E045 C1                 POP  BC
E046 C5                 PUSH BC
E047 CD1CE0             CALL DRAW_2_BC     ;Draw second line
E04A C1                 POP  BC
E04B D1                 POP  DE
E04C D5                 PUSH DE
E04D 4B                 LD   C,E
E04E 1836               JR   PAR_2         ;Jump to draw remaining two lines

E050 CD22E0   PARALLGRM CALL TEST_MRKR     ;Return if marker not in use
E053 ED5B12DB           LD   DE,(MARKER+2) ;DE= marker coordinates
E057 2A0EDB             LD   HL,(ORIGIN+2) ;HL= origin coordinates
E05A 79                 LD   A,C
E05B 93                 SUB  E
E05C 3804               JR   C,PAR_NEG1
E05E 85                 ADD  A,L           ;A= x coordinate of 4th vertex
E05F D8                 RET  C             ;Return if off screen
E060 1802               JR   PAR_X4
E062 85       PAR_NEG1  ADD  A,L           ;A= x coordinate of 4th vertex
E063 D0                 RET  NC            ;Return if off screen
E064 08       PAR_X4    EX   AF,AF'        ;Store in A'
E065 78                 LD   A,B
E066 92                 SUB  D
E067 3807               JR   C,PAR_NEG2
E069 84                 ADD  A,H           ;A= y coordinate of 4th vertex
E06A D8                 RET  C             ;Return if out of range
E06B FEB0               CP   #B0
E06D D0                 RET  NC            ;Return if off screen
E06E 1802               JR   PAR_Y4
E070 84       PAR_NEG2  ADD  A,H           ;A= y coordinate of 4th vertex
E071 D0                 RET  NC            ;Return if off screen
E072 C5       PAR_Y4    PUSH BC
E073 E5                 PUSH HL
E074 67                 LD   H,A
E075 08                 EX   AF,AF'
E076 6F                 LD   L,A           ;HL= coordinates of 4th vertex
E077 E5                 PUSH HL
E078 C5                 PUSH BC
E079 42                 LD   B,D
E07A 4B                 LD   C,E
E07B CD1CE0             CALL DRAW_2_BC     ;Draw first line
E07E C1                 POP  BC
E07F CD1CE0   PAR_3     CALL DRAW_2_BC     ;Draw next line
E082 CD38DF             CALL CANCEL_MK     ;Cancel marker cursor
E085 C1                 POP  BC
E086 CD1CE0   PAR_2     CALL DRAW_2_BC     ;Draw next line
E089 C1                 POP  BC
E08A CD1CE0             CALL DRAW_2_BC     ;Draw next line
E08D 180A               JR   CC_MOVE

E08F C5       CIRC_CENT PUSH BC
E090 CDA0E0             CALL GETCURSOR     ;Store cursor coordinates
                                           ;in calculator memories
E093 CDC9E0   CC_FIN    CALL CIRCLEARG     ;Calculate parameters for
                                           ;CIRCLE routine
E096 CD2D23             CALL CIRCLE+13     ;Draw circle
E099 C1       CC_MOVE   POP  BC            ;BC= cursor coordinates
E09A CD41DD             CALL PIX_ADDR      ;HL= cursor position
E09D C3F3DE             JP   MOVE          ;Move origin
E0A0 21925C   GETCURSOR LD   HL,MEMBOT
E0A3 22655C             LD   (STKEND),HL   ;Point calculator stack into memory
E0A6 210CDB             LD   HL,#DB0C
E0A9 1E03               LD   E,#03         ;E= number of cursors
E0AB 23       CC_LOOP   INC  HL
E0AC 23                 INC  HL
E0AD 4E                 LD   C,(HL)
E0AE 23                 INC  HL
E0AF 46                 LD   B,(HL)
E0B0 23                 INC  HL
E0B1 CDEADE             CALL ADJUST_B      ;Adjust to ROM convention
E0B4 E5                 PUSH HL
E0B5 D5                 PUSH DE
E0B6 C5                 PUSH BC
E0B7 78                 LD   A,B
E0B8 CD282D             CALL STACK_A       ;Stack y coordinate
E0BB C1                 POP  BC
E0BC 79                 LD   A,C
E0BD CD282D             CALL STACK_A       ;Stack x coordinate
E0C0 D1                 POP  DE
E0C1 E1                 POP  HL
E0C2 1D                 DEC  E
E0C3 20E6               JR   NZ,CC_LOOP
E0C5 CDC516             CALL SET_STK       ;Restore calculator stack
E0C8 C9                 RET
E0C9 EF       CIRCLEARG RST  #28           ;Engage the calculator
E0CA E1                 recall M1          Ox
E0CB E0                 recall M0          Ox,Oy
E0CC 31                 duplicate          Ox,Oy,Oy
     E4                 recall M4          Ox,Oy,Oy,Cy
     03                 subtract           Ox,Oy,Oy-Cy
E0CF 31                 duplicate          Ox,Oy,Oy-Cy,Oy-Cy
     04                 multiply           Ox,Oy,(Oy-Cy)^2
     E1                 recall M1          Ox,Oy,(Oy-Cy)^2,Ox
E0D2 E5                 recall M5          Ox,Oy,(Oy-Cy)^2,Ox,Cx
E0D3 03                 subtract           Ox,Oy,(Oy-Cy)^2,Ox-Cx
E0D4 31                 duplicate          Ox,Oy,(Oy-Cy)^2,Ox-Cx,Ox-Cx
     04                 multiply           Ox,Oy,(Oy-Cy)^2,(Ox-Cx)^2
     0F                 add                Ox,Oy,(Oy-Cy)^2+(Ox-Cx)^2
E0D7 28                 sqr                Ox,Oy,radius
     38                 end calc
E0D9 C9                 RET

E0DA EF       MATRIX    RST  #28
E0DB E2                 recall M2          My
     31                 duplicate          My,My
     04                 multiply           My^2
E0DE E0                 recall M0          My^2,Oy
E0DF 31                 duplicate          My^2,Oy,Oy
     04                 multiply           My^2,Oy^2
     03                 subtract           My^2-Oy^2
E0E2 E3                 recall M3          My^2-Oy^2,Mx
E0E3 31                 duplicate          My^2-Oy^2,Mx,Mx
     04                 multiply           My^2-Oy^2,Mx^2
     0F                 add                My^2-Oy^2+Mx^2
E0E6 E1                 recall M1          My^2-Oy^2+Mx^2,Ox
E0E7 31                 duplicate          My^2-Oy^2+Mx^2,Ox,Ox
     04                 multiply           My^2-Oy^2+Mx^2,Ox^2
     03                 subtract           My^2-Oy^2+Mx^2-Ox^2
E0EA A2                 const half         My^2-Oy^2+Mx^2-Ox^2,1/2
E0EB 04                 multiply           C
E0EC E2                 recall M2          C,My
     E0                 recall M0          C,My,Oy
     03                 subtract           C,A
E0EF C0                 store M0           C,A
E0F0 02                 delete             C
E0F1 E3                 recall M3          C,Mx
E0F2 E1                 recall M1          C,Mx,Ox
E0F3 03                 subtract           C,B
E0F4 C1                 store M1           C,B
E0F5 02                 delete             C
E0F6 38                 end calc
     C9                 RET

E0F8 CDDAE0   CALC_CENT CALL MATRIX        ;Calculate A, B and C
E0FB FD362E9C           LD   (MEMBOT),#9C
E0FF CDDAE0             CALL MATRIX        ;Calculate D, E and F
E102 FD362E92           LD   (MEMBOT),#92
E106 EF                 RST  #28           C,F
E107 C4                 store M4           C,F
     02                 delete             C
     C5                 store M5           C
E10A 02                 delete
E10B E1                 recall M1          B
E10C E2                 recall M2          B,D
     04                 multiply           B*D
     E0                 recall M0          B*D,A
E10F E3                 recall M3          B*D,A,E
E110 04                 multiply           B*D,A*E
E111 03                 subtract           Det
E112 31                 duplicate          Det,Det
     30                 eq Z               Det,Det=0
     0017               jump_true,NOT_POS  Det
E116 31                 duplicate          Det,Det
     E5                 recall M5          Det,Det,C
     E2                 recall M2          Det,Det,C,D
E119 04                 multiply           Det,Det,C*D
E11A E0                 recall M0          Det,Det,C*D,A
E11B E4                 recall M4          Det,Det,C*D,A,F
     04                 multiply           Det,Det,C*D,A*F
     03                 subtract           Det,Det,C*D-A*F
E11E 01                 exchange           Det,C*D-A*F,Det
     05                 divide             Det,X
     01                 exchange           X,Det
E121 E1                 recall M1          X,Det,B
E122 E4                 recall M4          X,Det,B,F
     04                 multiply           X,Det,B*F
     E5                 recall M5          X,Det,B*F,C
E125 E3                 recall M3          X,Det,B*F,C,E
E126 04                 multiply           X,Det,B*F,C*E
E127 03                 subtract           X,Det,B*F-C*E
E128 01                 exchange           X,B*F-C*E,Det
     05                 divide             X,Y
     38                 end calc
E12B C9                 RET
E12C 38       NOT_POS   end calc
E12D E1                 POP  HL            ;HL= return address
E12E C1                 POP  BC            ;BC= current coordinates
E12F C9                 RET                ;Return from subroutine

E130 CD22E0   CIRC_THRU CALL TEST_MRKR 
E133 C5                 PUSH BC
E134 CDA0E0             CALL GETCURSOR     ;Get current coordinates
                                           ;into calculator memories
E137 EF                 RST  #28
E138 E4                 recall M4          Cy
     E5                 recall M5          Cy,Cx
     38                 end calc
E13B CDF8E0             CALL CALC_CENT     ;Calculate the centre of the circle
E13E EF                 RST  #28
E13F C0                 store M0           M0=y
E140 02                 delete
E141 C1                 store M1           M1=x
E142 02                 delete
E143 C5                 store M5           M5=Cx
E144 02                 delete
E145 C4                 store M4           M4=Cy
     02                 delete
     38                 end calc
E148 CD38DF             CALL CANCEL_MK 
E14B C393E0             JP   CC_FIN

E14E 2A615C   CHK_INPUT LD   HL,(WORKSP)   ;Point CH_ADD to the start of
E151 225D5C             LD   (CH_ADD),HL   ;the INPUT string
E154 CDFB24             CALL SCANNING      ;Evaluate or check the expression
E157 3A3B5C             LD   A,(FLAGS)
E15A FD5637             LD   D,(FLAGX)     ;Check that the type of input
E15D AA                 XOR  D             ;(numeric or string) matches
E15E E640               AND  #40           ;that expected
E160 2004               JR   NZ,INP_WRONG  ;Jump if not
E162 DF                 RST  #18           ;A= byte following expression
E163 FE0D               CP   "enter"       ;Return provided that the
E165 C8                 RET  Z             ;byte is "enter"
E166 CF       INP_WRONG RST  #08           ;Use the error handling routine
E167 0B                 DEFB #0B           ;to generate a flashing "?"

E168 E5       INPUT_ITM PUSH HL            ;Stack the registers
E169 C5                 PUSH BC
E16A F5                 PUSH AF
E16B AF                 XOR  A             ;A= 0
E16C CD0116             CALL CHAN_OPEN     ;Select channel zero (lower screen)
E16F ED5B615C           LD   DE,(WORKSP)
E173 2A635C             LD   HL,(STKBOT)   ;Clear the workspace without
E176 CDE519             CALL RECLAIM_1     ;destroying the calculator stack
E179 21715C             LD   HL,FLAGX
E17C 7E                 LD   A,(HL)        ;A= (FLAGX)
E17D E61F               AND  #1F           ;Clear bits relating to INPUT
E17F C1                 POP  BC            ;B= new values for FLAGX bits
E180 B0                 OR   B
E181 77                 LD   (HL),A        ;Assign new bits of (FLAGX)
E182 C1                 POP  BC            ;C= length of INPUT prompt
E183 C5                 PUSH BC
E184 0600               LD   B,#00
E186 F7                 RST  #30           ;Create sufficient room in workspace
E187 F1                 POP  AF            ;A= position of "C" cursor
E188 D1                 POP  DE            ;DE points to last byte of prompt
E189 EB                 EX   DE,HL
E18A EDB8               LDDR               ;Store prompt message in workspace
E18C 13       I_PR_LOOP INC  DE
E18D 3D                 DEC  A
E18E 20FC               JR   NZ,I_PR_LOOP
E190 ED535B5C           LD   (K_CUR),DE    ;Store position of "C" cursor
E194 FDCB377E           BIT  7,(FLAGX)
E198 2026               JR   NZ,I_LINE_1   ;Jump if doing INPUT LINE
E19A 2A5D5C             LD   HL,(CH_ADD)   ;Stack two of the system variables
E19D E5                 PUSH HL
E19E 2A3D5C             LD   HL,(ERR_SP)
E1A1 E5                 PUSH HL
E1A2 21A2E1   IERRORRET LD   HL,IERRORRET  ;Return here in case of
E1A5 E5                 PUSH HL            ;syntax error
E1A6 ED733D5C           LD   (ERR_SP),SP
E1AA 2A615C             LD   HL,(WORKSP)   ;HL points to INPUT string
E1AD CDA711             CALL REMOVE_FP     ;Remove any five-byte-forms
E1B0 FD3600FF           LD   (ERR_NR),#FF  ;Cancel any syntax error
E1B4 CD2C0F             CALL EDITOR        ;Input the expression
E1B7 FDCB01BE           RES  7,(FLAGS)     ;Signal "checking syntax"
E1BB CD4EE1             CALL CHK_INPUT     ;Check for syntax errors
E1BE 1803               JR   I_CONT
E1C0 CD2C0F   I_LINE_1  CALL EDITOR        ;Input the LINE string
E1C3 FD362200 I_CONT    LD   (K_CUR hi),#00;Cancel the "C" cursor
E1C7 CD1D11             CALL ED_COPY       ;Print input string in lower screen
E1CA ED4B825C           LD   BC,(ECHO_E)   ;BC= coords of last byte
                                           ;in lower part of screen
E1CE CDD90D             CALL CL_SET        ;Store this as print position
E1D1 21715C             LD   HL,FLAGX
E1D4 CBAE               RES  5,(HL)        ;Signal "edit mode"
E1D6 CB7E               BIT  7,(HL)
E1D8 CBBE               RES  7,(HL)        ;Cancel any INPUT LINE flag
E1DA 201C               JR   NZ,I_LINE_2   ;Jump if INPUT LINE
E1DC E1                 POP  HL            ;Cancel IERRORRET address
E1DD E1                 POP  HL
E1DE 223D5C             LD   (ERR_SP),HL   ;Restore error pointer
E1E1 E1                 POP  HL
E1E2 225F5C             LD   (X_PTR),HL    ;Store CH_ADD temporarily in X_PTR
E1E5 FDCB01FE           SET  7,(FLAGS)     ;Signal "evaluating"
E1E9 CD4EE1             CALL CHK_INPUT     ;Evaluate the expression
E1EC 2A5F5C             LD   HL,(X_PTR)
E1EF FD362600           LD   (X_PTR hi),#00;Cancel X_PTR
E1F3 225D5C             LD   (CH_ADD),HL   ;Restore CH_ADD to its former value
E1F6 180F               JR   I_EXIT

E1F8 2A635C   I_LINE_2  LD   HL,(STKBOT)
E1FB ED5B615C           LD   DE,(WORKSP)
E1FF 37                 SCF
E200 ED52               SBC  HL,DE         ;HL= length of INPUT LINE string
E202 44                 LD   B,H
E203 4D                 LD   C,L
E204 CDB22A             CALL STK_STO_$     ;Stack onto calculator stack
E207 C36E0D   I_EXIT    JP   CLS_LOWER     ;Empty the lower part of the 
                                           ;screen and return

E20A ED4B0EDB STARTLINE LD   BC,(ORIGIN+2) ;BC= coords of origin cursor
E20E CDEADE             CALL ADJUST_B      ;Adjust to ROM convention
E211 ED437D5C           LD   (COORDS),BC   ;Store as "last point plotted"
E215 C3A0E0             JP   GETCURSOR     ;Get cursor coordinates into
                                           ;calculator memories and return

E218 CD0AE2   ARC_START CALL STARTLINE     ;Prepare to start arc
E21B EF                 RST  #28           ;Activate the calculator
E21C E5                 recall M5          Cx
E21D E1                 recall M1          Cx,Ox
E21E 03                 subtract           Cx-Ox
E21F E4                 recall M4          Cx-Ox,Cy
     E0                 recall M0          Cx-Ox,Cy,Oy
     03                 subtract           Cx-Ox,Cy-Oy
E222 38                 end calc           ;These are the first two
E223 C9                 RET                ;DRAW parameters

E224 28292A   ARC_HELP
     A70D               DEFM ()*PI

E229 C5       ARC_RAD   PUSH BC            ;Stack cursor coordinates
E22A CD18E2             CALL ARC_START     ;Initialise calculator
E22D CDCCDC             CALL MESSAGE       ;Print prompt message in
E230 07                 DEFB #07           ;lower part of screen
E231 CDB6DD             CALL DRCURSORS     ;Draw cursors on screen
E234 3E60               LD   A,#60         ;Signal "input number"
E236 010502             LD   BC,#0205      ;B= position of "C" cursor
                                           ;C= length of help prompt
E239 2128E2             LD   HL,ARC_HELP+4
E23C CD68E1             CALL INPUT_ITM     ;Input number of radians
E23F CDB6DD             CALL DRCURSORS     ;Erase cursors from screen
E242 CD9423   ARC_END   CALL DRAW_ARC      ;Draw the arc
E245 C399E0             JP   CC_MOVE       ;Move the origin cursor and return

E248 C5       CALC_FN   PUSH BC
E249 011E00             LD   BC,#001E
E24C F7                 RST  #30           ;Make room in the workspace
E24D 11E3FF             LD   DE,#FFE3
E250 19                 ADD  HL,DE         ;HL points to start of space
E251 22685C             LD   (MEMBOT),HL   ;Use space as calculator memory
E254 C1                 POP  BC            ;B= calculator function code
E255 EF                 RST  #28           ;Use calculator to carry out
E256 3B38               DEFB #3B,#38       ;required function
E258 ED5B615C           LD   DE,(WORKSP)
E25C 2A635C             LD   HL,(STKBOT)
E25F CDE519             CALL RECLAIM_1     ;Reclaim memory just used
E262 C3CB16             JP   SET_STK+6     ;Restore original memory

E265 EF       ANGLE     RST  #28           ;Engage the calculator
E266 A3                 const pi/2         PI/2
E267 E4                 recall M4          PI/2,Cy
     E2                 recall M2          PI/2,Cy,My
     03                 substract          PI/2,Cy-My
E26A 36                 lt zero            PI/2,Cy<My?
     30                 not                PI/2,Cy>=My?
E26C 0002               jump true ANGLE_1  PI/2
E26E 1B                 negate             -PI/2
E26F E5       ANGLE_1   recall M5          1PI/2,Cx
E270 E3                 recall M3          1PI/2,Cx,Mx
E271 03                 subtract           1PI/2,Cx-Mx
E272 30                 eq zero            1PI/2,Cx=Mx?
     001D               jump true ANGLE_3  1PI/2
E275 E4                 recall M4          1PI/2,Cy
     E2                 recall M2          1PI/2,Cy,My
     03                 subtract           1PI/2,Cy-My
E278 E5                 recall M5          1PI/2,Cy-My,Cx
E279 E3                 recall M3          1PI/2,Cy-My,Cx,Mx
E27A 03                 subtract           1PI/2,Cy-My,Cx-Mx
E27B 05                 divide             c
E27C 38                 end calc
E27D 0624               LD B,"atn"         ;Calculator code for ATN
E27F CD48E2             CALL CALC_FN       1PI/2,ATN((Cy-My)/(Cx-Mx))
E282 EF                 RST  #28
E283 E5                 recall M5          1PI/2,ATN((Cy-My)/(Cx-Mx)),Cx
E284 E3                 recall M3          1PI/2,ATN((Cy-My)/(Cx-Mx)),Cx,Mx
E285 03                 subtract           1PI/2,ATN((Cy-My)/(Cx-Mx)),Cx-Mx
E286 36                 lt zero            1PI/2,ATN((Cy-My)/(Cx-Mx)),Cx<Mx?
     0005               jump true ANGLE_2  1PI/2,ATN((Cy-My)/(Cx-Mx))
E289 01                 exchange           ATN((Cy-My)/(Cx-Mx)),1PI/2
     02                 delete             ATN((Cy-My)/(Cx-Mx))
     3305               jump ANGLE_3
E28D 01       ANGLE_2   exchange           ATN((Cy-My)/(Cx-Mx)),1PI/2
     31                 duplicate          ATN((Cy-My)/(Cx-Mx)),1PI/2,1PI/2
     0F                 add                ATN((Cy-My)/(Cx-Mx)),1PI
E290 0F                 add                ATN((Cy-My)/(Cx-Mx))1PI
E291 38                 end calc
E292 C9                 RET

E293 CD65E2   ANGLESWAP CALL ANGLE         ;Calculate angle
E296 EF       SWAP_MEMS RST  #28           ;Use the calculator
E297 E0                 recall M0          Oy
E298 E1                 recall M1          Oy,Ox
E299 E4                 recall M4          Oy,Ox,Cy
     E5                 recall M5          Oy,Ox,Cy,Cx
     C1                 store M1           (M1 now stores Cx)
E29C 02                 delete             Oy,Ox,Cy
E29D C0                 store M0           (M0 now stores Cy)
E29E 02                 delete             Oy,Ox
E29F C5                 store M5           (M5 now stores Ox)
E2A0 02                 delete             Oy
E2A1 C4                 store M4           (M4 now stores Oy)
     02                 delete
     38                 end calc
E2A4 C9                 RET

E2A5 CD22E0   ARC_USING CALL TEST_MRKR     ;Return if marker not active
E2A8 C5                 PUSH BC            ;Stack coordinates
E2A9 CD18E2             CALL ARC_START     ;Initialise calculator
E2AC CD93E2   ARC_US_2  CALL ANGLESWAP     ;Calculate main cursor angle
E2AF CD93E2             CALL ANGLESWAP     ;Calculate origin cursor angle
E2B2 EF                 RST  #28           ;Activate the calculator
E2B3 03                 subtract           X,Y,Ac-Ao
E2B4 31                 duplicate          X,Y,Ac-Ao,Ac-Ao
     37                 gt zero            X,Y,Ac-Ao,Ac>Ao?
     0007               jump true ARC_US_3 X,Y,Ac-Ao
E2B8 A3                 const pi/2         X,Y,Ac-Ao,PI/2
E2B9 38                 end calc
E2BA 34                 INC  (HL)          X,Y,Ac-Ao,PI
E2BB 34                 INC  (HL)          X,Y,Ac-Ao,2*PI
E2BC EF                 RST  #28
E2BD 0F                 add                X,Y,Ac-Ao+2*PI
E2BE 38       ARC_US_3  end calc           ;Calculator stack now contains
                                           ;DRAW parameters
E2BF CD38DF             CALL CANCEL_MK     ;Cancel marker cursor
E2C2 C342E2             JP   ARC_END

E2C5 CD22E0   ARC_THRU  CALL TEST_MRKR     ;Return if marker not in use
E2C8 C5                 PUSH BC            ;Stack cursor coordinates
E2C9 CD18E2             CALL ARC_START     ;Initialise calculator
E2CC CDF8E0             CALL CALC_CENT     ;Calculate centre of curvature
E2CF CDA0E0             CALL GETCURSOR     ;Restore calculator memories
E2D2 111400             LD   DE,#0014
E2D5 19                 ADD  HL,DE
E2D6 22655C             LD   (STKEND),HL   ;Restore calculator stack
E2D9 EF                 RST  #28           X,Y,centre_x,centre_y
E2DA C2                 store M2           (M2 now stores centre_y)
     02                 delete             X,Y,centre_x
     C3                 store M3           (M3 now stores centre_x)
E2DD 02                 delete             X,Y
E2DE 38                 end calc
E2DF 18CB               JR   ARC_US_2

ADDR SUBROUTINE POINTED TO                  PURPOSE               HOW OBTAINED
---- ---------------------                  -------               ------------
E2E1 DDE4               DEFW E4DD,ITAL_OFF  Italics Off           SYM SHF/Q
E2E3 E2E4               DEFW E4E2,ITAL_HS   Half Slope Italics    SYM SHF/W
E2E5 E8E4               DEFW E4E8,ITAL_FS   Full Slope Italics    SYM SHF/E
E2E7 F2E4               DEFW E4F2,TEXT_EXIT Cancel Text Mode      CAP SHF/SPACE
E2E9 D0E4               DEFW E4D0,7_BIT     7 Bit Wide Toggle     TRUE VIDEO
E2EB D4E4               DEFW E4D4,BOLD      Bold Type Toggle      INVERSE VIDEO
E2ED 3AE3               DEFW E33A,CAPS_LOCK Caps Lock Toggle      CAPS LOCK
E2EF 5200               DEFW 0052,RET       Not Used              EDIT
E2F1 53E4               DEFW E453,TC_LEFT   Cursor Left           CURSOR LEFT
E2F3 45E4               DEFW E445,TC_RIGHT  Cursor Right          CURSOR RIGHT
E2F5 5FE4               DEFW E45F,TC_DOWN   Cursor Down           CURSOR DOWN
E2F7 72E4               DEFW E472,TC_UP     Cursor Up             CURSOR UP
E2F9 5200               DEFW 0052,RET       Not Used              DELETE
E2FB F2E4               DEFW E4F2,TEXT_EXIT Cancel Text Mode      ENTER
E2FD 01E5               DEFW E501,ALT_SIZE  Alter Chr Size        BOTH SHIFTS
E2FF 43E3               DEFW E343,GRAPHICS  Graphics Mode Toggle  GRAPHICS

E301 0100               DEFW 0001           HEIGHT of characters
E303 0100               DEFW 0001           WIDTH  of characters
E305 FF818181 TC_PIXEL
E309 818181FF                               PIXEL LAYOUT of text-cursor

E30D FDCB016E T_CHR     BIT  5,(FLAGS)
E311 28FA               JR   Z,T_CHR       ;Wait until a key is pressed
E313 FDCB01AE           RES  5,(FLAGS)     ;Signal "Ready for a new key"
E317 FD46CE             LD   B,(LAST_K)    ;B= character code of key pressed
E31A CD541F             CALL BREAK_KEY     ;Test for CAPS SHIFT/SPACE
E31D 3802               JR   C,T_CHR_1     ;Jump unless CAPS SHIFT/SPACE pressed
E31F 0603               LD   B,#03         ;03 signals CAPS SHIFT/SPACE
E321 78       T_CHR_1   LD   A,B           ;A= character code
E322 FEAA               CP   #AA
E324 D8                 RET  C             ;Return if A contains a valid code
E325 216A02             LD   HL,SYMBOL_CODES ;Point HL to ROM table of
                                           ;"Symbol Shift Character Codes"
E328 EDB1               CPIR               ;Locate character in table
E32A 11DBFF             LD   DE,#FFDB
E32D 19                 ADD  HL,DE         ;Reposition HL so that it now points
                                           ;to "Extended Mode with SHIFT" table
E32E 7E                 LD   A,(HL)        ;A= E-mode symbol on same key
E32F FEBF               CP   "IN"
E331 2002               JR   NZ,T_CHR_2    ;Jump unless SYM SHIFT/I pressed
E333 3E7F               LD   A,")"         ;COPYRIGHT symbol now on SYM SHIFT/I
E335 A7       T_CHR_2   AND  A
E336 F0                 RET  P             ;Return with codes 00, 01 or 02
E337 D6B5               SUB  #B5           ;SYM SHF/Q, SYM SHF/W and SYM SHF/E
E339 C9                 RET                ;respectively

E33A 3A6A5C   CAPS_LOCK LD   A,(FLAGS2)
E33D EE08               XOR  #08
E33F 326A5C             LD   (FLAGS2),A    ;Complement CAPS LOCK flag
E342 C9                 RET

E343 3A415C   GRAPHICS  LD   A,(MODE)
E346 EE02               XOR  #02
E348 32415C             LD   (MODE),A    ;Complement GRAPHICS flag
E34B C9                 RET

E34C C5       T_LOCATE  PUSH BC
E34D FE80               CP   #80
E34F 3006               JR   NC,T_LOC_1  ;Jump if A contains either a graphic
                                         ;symbol or a UDG
E351 ED4B365C           LD   BC,(CHARS)  ;Point BC to Pixel-Layout table in
                                         ;ROM, less 0100h
E355 1808               JR   T_LOC_2
E357 D690     T_LOC_1   SUB  #90
E359 380D               JR   C,T_LOC_3   ;Jump if A contains a graphic code
E35B ED4B7B5C           LD   BC,(UDG)    ;Point BC to Pixel-Layouts for UDGs
                                         ;(Note: Range of A is now 00h-19h)
E35F 6F       T_LOC_2   LD   L,A
E360 2600               LD   H,#00       ;HL= character code
E362 29                 ADD  HL,HL
E363 29                 ADD  HL,HL
E364 29                 ADD  HL,HL
E365 09                 ADD  HL,BC       ;HL points to pixel layout of
                                         ;required character
E366 C1                 POP  BC
E367 C9                 RET
E368 47       T_LOC_3   LD   B,A         ;Low nibble of B indicates which 
                                         ;graphic symbol is required
E369 CD380B             CALL PO_GR_1     ;Construct graphic symbol in MEMBOT
E36C 21925C             LD   HL,MEMBOT   ;Point HL to this newly created
                                         ;pixel layout
E36F C1                 POP  BC
E370 C9                 RET

E371 F5       PR_NZ_DE  PUSH AF          ;Stack the zero flag
E372 3E20               LD   A,"space"
E374 D7                 RST  #10         ;Print a space
E375 F1                 POP  AF          ;Restore the zero flag
E376 2007               JR   NZ,PR_NZ_1
E378 3E20               LD   A,"space"
E37A D7                 RST  #10         ;Print a second space
E37B 3E20               LD   A,"space"
E37D D7                 RST  #10         ;Print a third space
E37E C9                 RET
E37F 7A       PR_NZ_1   LD   A,D
E380 D7                 RST  #10         ;Print CHR$(D);
E381 7B                 LD   A,E
E382 D7                 RST  #10         ;Print CHR$(E);
E383 C9                 RET

E384 C5       T_COLOUR  PUSH BC
E385 D5                 PUSH DE
E386 E5                 PUSH HL          ;Stack registers
E387 CDDB0B             CALL PO_ATTR     ;Colour appropriate attribute byte
E38A E1                 POP  HL
E38B D1                 POP  DE
E38C C1                 POP  BC          ;Restore registers
E38D 23                 INC  HL          ;HL points to next byte in screen
E38E 3E08               LD   A,#08       ;A= number of pixels in this byte
E390 C9                 RET

E391 3E08     TX_PRINT  LD   A,#08
E393 08       TXLOOP_1  EX   AF,AF'      ;A'= number of rows in pixel layout
E394 3A01E3             LD   A,(HEIGHT)
E397 32675C             LD   (B_REG),A   ;(B_REG)= Number of times each row
                                         ;must be duplicated
E39A 3A40DB   TXLOOP_2  LD   A,(JFLAGS)
E39D EE10               XOR  #10
E39F 3240DB             LD   (JFLAGS),A  ;Complement ODD/EVEN ROW flag
E3A2 C5                 PUSH BC          ;Stack cursor coordinates
E3A3 D5                 PUSH DE          ;Stack pixel layout pointer
E3A4 E5                 PUSH HL          ;Stack address of screen-byte
                                         ;containing cursor
E3A5 79                 LD   A,C         ;A= column number of cursor (in pixels)
E3A6 E607               AND  #07
E3A8 4F                 LD   C,A         ;C= pos within screen-byte of cursor
E3A9 1A                 LD   A,(DE)
E3AA 57                 LD   D,A         ;D= current row from pixel layout
E3AB DDCB005E           BIT  3,(JFLAGS)
E3AF 2803               JR   Z,TXP_1     ;Jump unless using BOLD typeface
E3B1 87                 ADD  A,A         ;Shift left one bit; bit 0 reset
E3B2 B2                 OR   D           ;Use each bit twice, if set
E3B3 57                 LD   D,A         ;D now amended for BOLD type
E3B4 3A03E3   TXP_1     LD   A,(WIDTH)
E3B7 47                 LD   B,A         ;B= number of times each pixel
                                         ;must be duplicated
E3B8 3E08               LD   A,#08       ;A= number of pixels in screen-byte
E3BA 5F                 LD   E,A         ;E= number of bits in pixel layout row
E3BB 0C                 INC  C
E3BC 1803               JR   TXALIGN2
E3BE 3D       TXALIGN1  DEC  A           ;A= number of remaining pixels in (HL)
E3BF CB06               RLC  (HL)        ;Move next pixel from screen into bit 7
E3C1 0D       TXALIGN2  DEC  C
E3C2 20FA               JR   NZ,TXALIGN1 ;Pixel at cursor position now
                                         ;in bit 7 of (HL)
E3C4 C5       TXLOOP_3  PUSH BC          ;Stack character width (B)
E3C5 F5                 PUSH AF          ;Stack screen-byte pixel counter
E3C6 CB02               RLC  D           ;Move next pixel from pixel-layout
                                         ;into bit 0 of D

E3C8 FD4E57   TXLOOP_4  LD   C,(P_FLAG)  ;Bit 0 of C= OVER status
E3CB 7E                 LD   A,(HL)
E3CC 07                 RLCA             ;Bit 0 of A= current pixel from screen
E3CD A1                 AND  C           ;Bit 0 of A= 0 if OVER 0; or current
                                         ;pixel from screen if OVER 1
E3CE CB19               RR   C
E3D0 CB19               RR   C           ;Bit 0 of C= INVERSE status
E3D2 A9                 XOR  C           ;If INVERSE 1, then complement
                                         ;bit 0 of A
E3D3 AA                 XOR  D           ;Bit 0 of A= current pixel from
                                         ;required pixel-layout, with OVER and
                                         ;INVERSE correctly implemented
E3D4 1F                 RRA              ;Carry= pixel to print
E3D5 CB16               RL   (HL)        ;Bit 0 of (HL) correctly stores pixel
E3D7 F1                 POP  AF          ;A= number of remaining pixels in
                                         ;(HL) to consider
E3D8 3D                 DEC  A
E3D9 CC84E3             CALL Z,T_COLOUR  ;If all 8 bits of (HL) have been dealt
                                         ;with, then colour the attribute byte
                                         ;and point HL to next byte from screen
E3DC F5                 PUSH AF          ;Stack screen-byte pixel counter
E3DD 10E9               DJNZ TXLOOP_4    ;Duplicate pixel as many times as
                                         ;is required
E3DF F1                 POP  AF          ;A= screen-byte pixel counter
E3E0 C1                 POP  BC          ;B= number of times each pixel must
                                         ;be duplicated
E3E1 1D                 DEC  E
E3E2 20E0               JR   NZ,TXLOOP_3 ;Repeat this procedure for all pixels
                                         ;within current pixel-layout row
E3E4 FE08               CP   #08
E3E6 2808               JR   Z,TXALIGN4  ;Jump if HL points to a new byte
E3E8 CB06     TXALIGN3  RLC  (HL)        ;This loop realigns (HL)
E3EA 3D                 DEC  A           ;so that all pixels are back in
E3EB 20FB               JR   NZ,TXALIGN3 ;the right place
E3ED CD84E3             CALL T_COLOUR    ;Colour in the last attribute
E3F0 E1       TXALIGN4  POP  HL          ;HL points to first screen byte
                                         ;affected in current row
E3F1 D1                 POP  DE          ;DE points to current row of
                                         ;pixel-layout
E3F2 C1                 POP  BC          ;B= current row number
                                         ;C= column number of first pixel
                                         ;affected in current row
E3F3 CD36DD             CALL DOWN_PIX    ;Point HL and B one pixel down
E3F6 DDCB0046           BIT  0,(JFLAGS)
E3FA 280D               JR   Z,TXP_3     ;Jump unless printing in italics
E3FC DDCB004E           BIT  1,(JFLAGS)
E400 2004               JR   NZ,TXP_2    ;Jump if using full slope
E402 DDCB0066           BIT  4,(JFLAGS)  ;Test ODD/EVEN ROW flag
E406 C413DD   TXP_2     CALL NZ,LEFT_PIX ;If reqd, point HL and C one pix left
E409 FD352D   TXP_3     DEC  (B_REG)
E40C 208C               JR   NZ,TXLOOP_2 ;Repeat current pixel-layout row
                                         ;as many times as is required 
E40E 13                 INC  DE          ;DE points to next pixel-layout row
E40F 08                 EX   AF,AF'
E410 3D                 DEC  A
E411 2080               JR   NZ,TXLOOP_1 ;Repeat procedure for all rows
                                         ;of pixel-layout
E413 C9                 RET

E414 F5       TX_CURSOR PUSH AF
E415 C5                 PUSH BC
E416 D5                 PUSH DE
E417 E5                 PUSH HL          ;Stack all registers
E418 E5                 PUSH HL          ;Stack HL again
E419 2A905C             LD   HL,(MASK_T)
E41C E3                 EX   (SP),HL     ;Stack system variables MASK_T and
                                         ;P_FLAG; HL now restored
E41D E5                 PUSH HL
E41E 21FF01             LD   HL,#01FF
E421 22905C             LD   (MASK_T),HL ;Set INK 8; PAPER 8; BRIGHT 8;
                                         ;FLASH 8; OVER 1; INVERSE 0
E424 E1                 POP  HL
E425 1105E3             LD   DE,TC_PIXEL ;Point DE to pixel layout for cursor
E428 CD91E3             CALL TX_PRINT    ;Print the cursor onto the screen
E42B E1                 POP  HL
E42C 22905C             LD   (MASK_T),HL ;Restore original colours
E42F E1                 POP  HL
E430 D1                 POP  DE
E431 C1                 POP  BC
E432 F1                 POP  AF
E433 C9                 RET

E434 3A03E3   GET_WIDTH LD   A,(WIDTH)   ;A= width of character (in squares)
E437 D5                 PUSH DE
E438 5F                 LD   E,A
E439 87                 ADD  A,A
E43A 87                 ADD  A,A
E43B 87                 ADD  A,A         ;A= 8*(WIDTH)
E43C DDCB0056           BIT  2,(JFLAGS)
E440 2801               JR   Z,GET_WID_1 ;Jump unless using 7-bit typeface
E442 93                 SUB  E           ;In which case A= 7*(WIDTH)
E443 D1       GET_WID_1 POP  DE
E444 C9                 RET

E445 D5       TC_RIGHT  PUSH DE
E446 CD34E4             CALL GET_WIDTH
E449 5F                 LD   E,A         ;E= character width in pixels
E44A 87                 ADD  A,A         ;A= twice this width
E44B 81                 ADD  A,C
E44C 3802               JR   C,TCR_1     ;Jump if cursor right not possible
E44E 93                 SUB  E
E44F 4F                 LD   C,A         ;C= new column number of cursor
E450 D1       TCR_1     POP  DE
E451 182C               JR   J_PIXADDR
E453 D5       TC_LEFT   PUSH DE
E454 CD34E4             CALL GET_WIDTH
E457 5F                 LD   E,A         ;E= character width in pixels
E458 79                 LD   A,C         ;A= current cursor column number
E459 93                 SUB  E           ;A= new cursor column number
E45A D1                 POP  DE
E45B D8                 RET  C           ;Return if cursor left not possible
E45C 4F                 LD   C,A         ;C= new column number of cursor
E45D 1832               JR   TEST_CPOS
E45F D5       TC_DOWN   PUSH DE
E460 3A01E3             LD   A,(HEIGHT)  ;A= character height in squares
E463 87                 ADD  A,A
E464 87                 ADD  A,A
E465 87                 ADD  A,A
E466 5F                 LD   E,A         ;E= character height in pixels
E467 87                 ADD  A,A         ;A= twice this height
E468 80                 ADD  A,B
E469 FEB0               CP   #B0
E46B 3002               JR   NC,TCD_1    ;Jump if cursor down not possible
E46D 93                 SUB  E
E46E 47                 LD   B,A         ;B= new row number of cursor
E46F D1       TCD_1     POP  DE
E470 180D               JR   J_PIXADDR
E472 D5       TC_UP     PUSH DE
E473 3A01E3             LD   A,(HEIGHT)  ;A= character height in squares
E476 87                 ADD  A,A
E477 87                 ADD  A,A
E478 87                 ADD  A,A
E479 5F                 LD   E,A         ;E= character height in pixels
E47A 78                 LD   A,B         ;A= current row number of cursor
E47B 93                 SUB  E           ;A= new row number of cursor
E47C D1                 POP  DE
E47D D8                 RET  C           ;Return if cursor up not possible
E47E 47                 LD   B,A         ;B= new row number of cursor
E47F C341DD   J_PIXADDR JP   PIX_ADDR    ;Calculate HL= address of screen-byte
                                         ;containing cursor, and return

E482 7E       TESTCSIZE LD   A,(HL)      ;A= character width (or height)
E483 A7                 AND  A
E484 2804               JR   Z,TCS_1     ;Jump if width (or height) zero
E486 FE0A               CP   #0A
E488 3802               JR   C,TCS_2     ;Jump if width (or height) valid
E48A 3601     TCS_1     LD   (HL),#01    ;Set width (or height) to 01
E48C 23       TCS_2     INC  HL
E48D 3600               LD   (HL),#00    ;Reset high byte
E48F 23                 INC  HL
E490 C9                 RET

E491 E5       TEST_CPOS PUSH HL
E492 2101E3             LD   HL,HEIGHT
E495 CD82E4             CALL TESTCSIZE   ;Ensure valid character height
E498 CD82E4             CALL TESTCSIZE   ;Ensure valid character width
E49B E1                 POP  HL
E49C AF                 XOR  A           ;A= 00
E49D DDCB0046           BIT  0,(JFLAGS)
E4A1 280C               JR   Z,TCP_1     ;Jump unless printing in italics
E4A3 3A03E3             LD   A,(WIDTH)   ;A= character width in squares
E4A6 87                 ADD  A,A
E4A7 87                 ADD  A,A
E4A8 DDCB004E           BIT  1,(JFLAGS)
E4AC 2801               JR   Z,TCP_1     ;Jump if using half-slope
E4AE 87                 ADD  A,A
E4AF B9       TCP_1     CP   C
E4B0 3801               JR   C,TCP_2     ;Jump unless current cursor position
                                         ;overhangs left-hand edge of screen
E4B2 4F                 LD   C,A         ;Cursor now as far left as possible
E4B3 CD34E4   TCP_2     CALL GET_WIDTH   ;A= character width in pixels
E4B6 81                 ADD  A,C
E4B7 3004               JR   NC,TCP_3    ;Jump unless current cursor position
                                         ;overhangs right-hand edge of screen
E4B9 91                 SUB  C
E4BA ED44               NEG
E4BC 4F                 LD   C,A         ;Cursor now as far right as possible
E4BD 3A01E3   TCP_3     LD   A,(HEIGHT)  ;A= character height in squares
E4C0 87                 ADD  A,A
E4C1 87                 ADD  A,A
E4C2 87                 ADD  A,A         ;A= character height in pixels
E4C3 80                 ADD  A,B
E4C4 FEB0               CP   #B0
E4C6 3806               JR   C,TCP_4     ;Jump unless current cursor position
                                         ;overhangs bottom of screen
E4C8 90                 SUB  B
E4C9 ED44               NEG
E4CB C6B0               ADD  A,#B0
E4CD 47                 LD   B,A         ;Cursor now as far down as possible
E4CE 18AF     TCP_4     JR   J_PIXADDR   ;Calculate HL= address of screen-byte
                                         ;containing cursor, and return

E4D0 3E04     7_BIT     LD   A,#04       ;Bit 2 of A set
E4D2 1802               JR   BOLD_7
E4D4 3E08     BOLD      LD   A,#08       ;Bit 3 of A set
E4D6 DDAE00   BOLD_7    XOR  (JFLAGS)    ;Complement required bit
E4D9 3240DB             LD   (JFLAGS),A
E4DC C9                 RET
E4DD DDCB0086 ITAL_OFF  RES  0,(JFLAGS)  ;Signal "Not printing in italics"
E4E1 C9                 RET
E4E2 DDCB008E ITAL_HS   RES  1,(JFLAGS)  ;Signal "Not using full slope"
E4E6 1804               JR   ITAL_1
E4E8 DDCB00CE ITAL_FS   SET  1,(JFLAGS)  ;Signal "Using full slope"
E4EC DDCB00C6 ITAL_1    SET  0,(JFLAGS)  ;Signal "Printing in italics"
E4F0 189F               JR   TEST_CPOS   ;Adjust cursor position if necessary
E4F2 2214DB   TEXT_EXIT LD   (CURSOR),HL ;Set final position of cursor
E4F5 ED4316DB           LD   (CURSOR+2),BC ;Store final cursor coordinates
E4F9 CD6E0D             CALL CLS_LOWER   ;Clear lower part of screen
E4FC F1                 POP  AF          ;Drop return address TEXT_LOOP
E4FD C9                 RET              ;Return to LSD Main Loop

E4FE CD91E4   ASZ_1     CALL TEST_CPOS   ;Ensure that cursor will fit on screen
E501 CD14E4   ALT_SIZE  CALL TX_CURSOR   ;Print cursor on screen
E504 FDCB01AE           RES  5,(FLAGS)   ;Signal "Ready for a new key"
E508 FDCB016E ASZ_2     BIT  5,(FLAGS)
E50C 28FA               JR   Z,ASZ_2     ;Wait until a key is pressed
                                         ;Note that bit 5 of FLAGS remains SET
                                         ;on exiting this loop
E50E C5                 PUSH BC          ;Stack cursor coordinates
E50F E5                 PUSH HL          ;Stack cursor address
E510 CD8E02             CALL KEY_SCAN    ;E= keyboard code for this key
E513 E1                 POP  HL          ;HL= cursor address
E514 C1                 POP  BC          ;BC= cursor coordinates
E515 7B                 LD   A,E         ;A= keyboard code of key pressed
E516 CD14E4             CALL TX_CURSOR   ;"Undraw" cursor from screen
E519 FE20               CP   #20
E51B 2005               JR   NZ,ASZ_3    ;Jump unless SPACE pressed
E51D FDCB01AE           RES  5,(FLAGS)   ;Signal "Ready for a new key"
E521 C9                 RET              ;Return to TEXT_LOOP
E522 FE04     ASZ_3     CP   #04
E524 200B               JR   NZ,ASZ_4    ;Jump unless 5 pressed with either
                                         ;shift (CURSOR LEFT)
E526 3A03E3             LD   A,(WIDTH)   ;A= width of character
E529 3D                 DEC  A
E52A 28D5               JR   Z,ALT_SIZE  ;Jump back if width=1
E52C 3203E3             LD   (WIDTH),A   ;Decrement width
E52F 18D0               JR   ALT_SIZE
E531 FE13     ASZ_4     CP   #13
E533 200D               JR   NZ,ASZ_5    ;Jump unless 8 pressed with either
                                         ;shift (CURSOR RIGHT)
E535 3A03E3             LD   A,(WIDTH)   ;A= width of character
E538 3C                 INC  A
E539 FE0A               CP   #0A
E53B 30C4               JR   NC,ALT_SIZE ;Jump if width greater than 9
E53D 3203E3             LD   (WIDTH),A   ;Increment width
E540 18BC               JR   ASZ_1       ;Jump back to check position on screen

E542 FE03     ASZ_5     CP   #03
E544 200D               JR   NZ,ASZ_6    ;Jump unless 6 pressed with either
                                         ;shift (CURSOR DOWN)
E546 3A01E3             LD   A,(HEIGHT)  ;A= height of characters
E549 3C                 INC  A
E54A FE0A               CP   #0A
E54C 30B3               JR   NC,ALT_SIZE ;Jump back if height greater than 9
E54E 3201E3             LD   (HEIGHT),A  ;Increment height
E551 18AB               JR   ASZ_1       ;Jump back to check position on screen
E553 FE0B     ASZ_6     CP   #0B
E555 C0                 RET  NZ          ;Return unless 7 pressed with either
                                         ;shift (CURSOR UP). Note that since
                                         ;bit 5 of FLAGS is set, the key
                                         ;pressed will be re-interpreted
                                         ;within the main TEXT_LOOP.
E556 3A01E3             LD   A,(HEIGHT)  ;A= height of characters
E559 3D                 DEC  A
E55A 28A5               JR   Z,ALT_SIZE  ;Jump back if height=1
E55C 3201E3             LD   (HEIGHT),A  ;Decrement height
E55F 18A0               JR   ALT_SIZE

;This is the main entry point for TEXT MODE. When you press the TEXT key (key P)
;while running the Light Screen Designer, control commences from this point. On
;entry B contains the row number, and C the column number, of the main cursor.
;HL points to the byte from the screen which contains this cursor.
E561 CD91E4   TEXT_MODE CALL TEST_CPOS   ;Move cursor if necessary
E564 C5                 PUSH BC          ;Stack coordinates
E565 E5                 PUSH HL          ;Stack cursor position
E566 CDCCDC             CALL MESSAGE
E569 08                 DEFB #08         ;Print "Now in text mode"
E56A E1                 POP  HL
E56B C1                 POP  BC
E56C C5       TEXT_LOOP PUSH BC          ;Stack coordinates
E56D E5                 PUSH HL          ;Stack cursor position
E56E 3A3B5C             LD   A,(FLAGS)
E571 F5                 PUSH AF          ;Stack FLAGS (in particular bit 5)
E572 AF                 XOR  A           ;A= 00
E573 CD0116             CALL CHAN_OPEN   ;Select channel zero (lower screen)
E576 F1                 POP  AF
E577 323B5C             LD   (FLAGS),A   ;Restore bit 5 of FLAGS
E57A 011101             LD   BC,#0111
E57D CD9B0A             CALL AT_BC       ;PRINT AT 1,17d;
E580 3E4C               LD   A,"L"
E582 FDCB305E           BIT  3,(FLAGS2)
E586 2802               JR   Z,TEXT_1    ;Jump unless CAPS LOCK on
E588 3E43               LD   A,"C"
E58A FDCB074E TEXT_1    BIT  1,(MODE)
E58E 2802               JR   Z,TEXT_2    ;Jump unless in GRAPHICS mode
E590 3E47               LD   A,"G"
E592 D7       TEXT_2    RST  #10         ;Print cursor mode
E593 115348             LD   DE,#4853    ;D= "H", E= "S"
E596 DDCB004E           BIT  1,(JFLAGS)
E59A 2802               JR   Z,TEXT_3    ;Jump unless using full slope
E59C 1646               LD   D,"F"
E59E DDCB0046 TEXT_3    BIT  0,(JFLAGS)
E5A2 CD71E3             CALL PR_NZ_DE    ;Print italic status
E5A5 114D43             LD   DE,#434D    ;D= "C", E= "M"
E5A8 DDCB0056           BIT  2,(JFLAGS)
E5AC CD71E3             CALL PR_NZ_DE    ;Print compressed letter status
E5AF 114F42             LD   DE,#424F    ;D= "B", E= "O"
E5B2 DDCB005E           BIT  3,(JFLAGS)
E5B6 CD71E3             CALL PR_NZ_DE    ;Print bold status
E5B9 E1                 POP  HL
E5BA C1                 POP  BC
E5BB CD14E4             CALL TX_CURSOR   ;Draw the text cursor
E5BE C5                 PUSH BC
E5BF E5                 PUSH HL
E5C0 CD0DE3             CALL T_CHR       ;Wait for key pressed; A= chr code
E5C3 E1                 POP  HL
E5C4 C1                 POP  BC
E5C5 CD14E4             CALL TX_CURSOR   ;"Undraw" the text cursor
E5C8 116CE5             LD   DE,TEXT_LOOP
E5CB D5                 PUSH DE          ;Stack TEXT_LOOP as return address
E5CC F5                 PUSH AF          ;Stack key pressed
E5CD E5                 PUSH HL
E5CE C5                 PUSH BC
E5CF 3E02               LD   A,#02
E5D1 CD0116             CALL CHAN_OPEN   ;Select channel 2 (main screen)
E5D4 BF                 CP   A           ;Set the zero flag
E5D5 CD5E0D             CALL TEMPS_P     ;Reset OVER and INVERSE from
                                         ;permanent colours
E5D8 C1                 POP  BC
E5D9 E1                 POP  HL
E5DA F1                 POP  AF          ;A= key just pressed
E5DB FE20               CP   #20
E5DD 300F               JR   NC,TEXT_4   ;Jump unless A contains a control code
E5DF E5                 PUSH HL
E5E0 6F                 LD   L,A
E5E1 2600               LD   H,#00
E5E3 11E1E2             LD   DE,#E2E1
E5E6 29                 ADD  HL,HL
E5E7 19                 ADD  HL,DE       ;HL points to subroutine address
E5E8 5E                 LD   E,(HL)
E5E9 23                 INC  HL
E5EA 56                 LD   D,(HL)      ;DE= subroutine address
E5EB E1                 POP  HL          ;Restore HL value
E5EC D5                 PUSH DE
E5ED C9                 RET              ;Jump to required subroutine

E5EE C5       TEXT_4    PUSH BC
E5EF E5                 PUSH HL
E5F0 CD4CE3             CALL T_LOCATE    ;HL= address of pixel layout
E5F3 EB                 EX   DE,HL       ;DE= address of pixel layout
E5F4 E1                 POP  HL
E5F5 C1                 POP  BC
E5F6 C5                 PUSH BC          ;Stack cursor coordinates
E5F7 CD91E3             CALL TX_PRINT    ;Print character on screen
E5FA C1                 POP  BC          ;Restore cursor coordinates
E5FB C345E4             JP   TC_RIGHT    ;Move cursor right, if possible,
                                         ;and return

E5FE EF       ELL_SUB   RST  #28           ;Engage the calculator
E5FF EE                 recall ME          Px
     E5                 recall M5          Px,t
E601 20                 cos                Px,cos t
     E6                 recall M6          Px,cos t,a
E603 04                 multiply           Px,a*cos t
E604 CA                 store MA           (MA= a*cos t)
     EC                 recall MC          Px,a*cos t,cos s
     04                 multiply           Px,a*cos s*cos t
E607 0F                 add                Px+a*cos s*cos t
E608 E5                 recall M5          Px+a*cos s*cos t,t
E609 1F                 sin                Px+a*cos s*cos t,sin t
E60A E7                 recall M7          Px+a*cos s*cos t,sin t,b
E60B 04                 multiply           Px+a*cos s*cos t,b*sin t
E60C CB                 store MB           (MB= b*sin t)
     ED                 recall MD          Px+a*cos s*cos t,b*sin t,sin s
E60E 04                 multiply           Px+a*cos s*cos t,b*sin s*sin t
E60F 03                 subtract           Px+a*cos s*cos t-b*sin s*sin t
E610 A2                 const half         Px+a*cos s*cos t-b*sin s*sin t,1/2
E611 0F                 add                Px+a*cos s*cos t-b*sin s*sin t+1/2
E612 27                 int                x
E613 EF                 recall MF          x,Py
E614 EA                 recall MA          x,Py,a*cos t
     ED                 recall MD          x,Py,a*cos t,sin s
     04                 multiply           x,Py,a*sin s*cos t
E617 0F                 add                x,Py+a*sin s*cos t
E618 EB                 recall MB          x,Py+a*sin s*cos t,b*sin t
E619 EC                 recall MC          x,Py+a*sin s*cos t,b*sin t,cos s
     04                 multiply           x,Py+a*sin s*cos t,b*cos s*sin t
     0F                 add                x,Py+a*sin s*cos t+b*cos s*sin t
E61C A2                 const half         x,Py+a*sin s*cos t+b*cos s*sin t,1/2
E61D 0F                 add                x,Py+a*sin s*cos t+b*cos s*sin t+1/2
E61E 27                 int                x,y
E61F E5                 recall M5          x,y,t
E620 E3                 recall M3          x,y,t,i
E621 0F                 add                x,y,t+i
E622 C5                 store M5           (M5= newly incremented angle t+i)
E623 02                 delete             x,y
E624 38                 end calc           ;Disengage the calculator
E625 C9                 RET

E626 F5       ELL_Q     PUSH AF            ;Stack the carry flag
E627 EF                 RST  #28           ;Engage the calculator
E628 E6                 recall M6          a
     E7                 recall M7          a,b
E62A 0F                 add                a+b
E62B 34B00E2C19         stk data pi/(2*sqr 2) a+b,pi/(2*sqr 2)
E630 04                 multiply           (a+b)*pi/(2*sqr 2)
E631 27                 int                int((a+b)*pi/(2*sqr 2))
E632 A1                 const one          int((a+b)*pi/(2*sqr 2)),1
E633 0F                 add                N
E634 31                 duplicate          N,N
     A3                 const pi/2         N,N,pi/2
     01                 exchange           N,pi/2,N
E637 05                 divide             N,i
E638 C3                 store M3           (M3= i, the increment in angle)
     02                 delete             N
     38                 end calc           ;Disengage the calculator
E63B CDA22D             CALL FP_TO_BC      ;BC= N (number of increments in 
                                           ;a quarter ellipse)
E63E F1                 POP  AF            ;Restore the carry flag
E63F 3806               JR   C,DR_ELL      ;Jump if only quarter ellipse reqd
E641 60                 LD   H,B
E642 69                 LD   L,C
E643 29                 ADD  HL,HL
E644 29                 ADD  HL,HL
E645 44                 LD   B,H
E646 4D                 LD   C,L           ;BC= 4*N
E647 21FEE5   DR_ELL    LD   HL,ELL_SUB    ;HL= address of ellipse subroutine

E64A C5       CURVE     PUSH BC            ;Stack number of passes
E64B E5                 PUSH HL            ;Stack address of subroutine
E64C CD2C16             CALL CALL_JUMP     ;Call subroutine required
E64F CDDC22             CALL PLOT          ;Plot the first point
E652 E1                 POP  HL            ;HL= subroutine address
E653 C1                 POP  BC            ;BC= number of passes
E654 C5       CV_LOOP   PUSH BC
E655 E5                 PUSH HL
E656 CD2C16             CALL CALL_JUMP     ;Call subroutine
E659 CD0723             CALL STK_TO_BC     ;B= x; C= y
E65C 110101             LD   DE,#0101
E65F 78                 LD   A,B           ;A= x
;[I think that the commands at E660 & E66B should be swapped around,]
;[as COORDS holds (x,y), not (y,x).                             JimG]
E660 FD9644             SUB  (COORDS+1)    ;A= x displacement
E663 3004               JR   NC,CV_1
E665 16FF               LD   D,#FF         ;D= FF to indicate x disp negative
E667 ED44               NEG                ;A= abs(x displacement)
E669 47       CV_1      LD   B,A           ;B= abs(x displacement)
E66A 79                 LD   A,C           ;A= y
E66B FD9643             SUB  (COORDS)      ;A= y displacement
E66E 3004               JR   NC,CV_2
E670 1EFF               LD   E,#FF         ;E= FF to indicate y disp negative
E672 ED44               NEG
E674 4F       CV_2      LD   C,A           ;C= abs(y displacement)
E675 CDBA24             CALL DRAW_3        ;Draw line segment
E678 CD541F             CALL BREAK_KEY     ;Test if CAPS SHIFT/SPACE pressed
E67B E1                 POP  HL
E67C C1                 POP  BC
E67D 3005               JR   NC,CV_EXIT    ;Jump if so
E67F 0B                 DEC  BC
E680 78                 LD   A,B
E681 B1                 OR   C
E682 20D0               JR   NZ,CV_LOOP    ;Loop back if not finished
E684 215827   CV_EXIT   LD   HL,#2758
E687 D9                 EXX                ;HL'= 2758
E688 C9                 RET

E689 F7       CREATEMEM RST  #30           ;Create memory in workspace
E68A 1B                 DEC  DE            ;DE points to first byte of area
E68B ED53685C           LD   (MEMBOT),DE   ;Point calculator memory to area
E68F C9                 RET

E690 CD22E0   ELLIPSE   CALL TEST_MRKR     ;Return if marker cursor not in use
E693 C5                 PUSH BC            ;Stack cursor coordinates
E694 CD0AE2             CALL STARTLINE     ;Get cursor coords into calc mems
E697 EF                 RST  #28           ;Engage the calculator
E698 E2                 recall M2          My
     E3                 recall M3          My,Mx
     E0                 recall M0          My,Mx,Oy
E69B E4                 recall M4          My,Mx,Oy,Cy
     0F                 add                My,Mx,Cy+Oy
     A2                 const half         My,Mx,Cy+Oy,1/2
E69E 04                 multiply           My,Mx,Py
E69F 31                 duplicate          My,Mx,Py,Py
     E4                 recall M4          My,Mx,Py,Py,Cy
     03                 subtract           My,Mx,Py,Py-Cy
E6A2 31                 duplicate          My,Mx,Py,Py-Cy,Py-Cy
     04                 multiply           My,Mx,Py,(Py-Cy)^2
     E5                 recall M5          My,Mx,Py,(Py-Cy)^2,Cx
E6A5 E1                 recall M1          My,Mx,Py,(Py-Cy)^2,Cx,Ox
E6A6 0F                 add                My,Mx,Py,(Py-Cy)^2,Cx+Ox
E6A7 A2                 const half         My,Mx,Py,(Py-Cy)^2,Cx+Ox,1/2
E6A8 04                 multiply           My,Mx,Py,(Py-Cy)^2,Px
E6A9 C3                 store M3           (M3= Px)
     E5                 recall M5          My,Mx,Py,(Py-Cy)^2,Px,Cx
     03                 subtract           My,Mx,Py,(Py-Cy)^2,Px-Cx
E6AC 31                 duplicate          My,Mx,Py,(Py-Cy)^2,Px-Cx,Px-Cx
     04                 mutliply           My,Mx,Py,(Py-Cy)^2,(Px-Cx)^2
     0F                 add                My,Mx,Py,(Py-Cy)^2+(Px-Cx)^2
E6AF E3                 recall M3          My,Mx,Py,(Py-Cy)^2+(Px-Cx)^2,Px
E6B0 01                 exchange           My,Mx,Py,Px,(Py-Cy)^2+(Px-Cx)^2
     28                 sqr                My,Mx,Py,Px,a
     01                 exchange           My,Mx,Py,a,Px
E6B3 C3                 store M3           (M3= Px)
     02                 delete             My,Mx,Py,a
     01                 exchange           My,Mx,a,Py
E6B6 C2                 store M2           (M2= Py)
     E3                 recall M3          My,Mx,a,Py,Px
     38                 end calc           ;Disengage the calculator
E6B9 CD65E2             CALL ANGLE         ;Calculate the inclination, s,
                                           ;of the major axis to the horizontal
E6BC 015000             LD   BC,#0050
E6BF CD89E6             CALL CREATEMEM     ;Create sixteen calculator memories
E6C2 EF                 RST  #28           ;Re-engage the calculator
                                           My,Mx,a,Py,Px,s
E6C3 C4                 store M4           (M4= s)
     02                 delete             My,Mx,a,Py,Px
     CE                 store ME           (ME= Px)
E6C6 02                 delete             My,Mx,a,Py
E6C7 CF                 store MF           (MF= Py)
E6C8 02                 delete             My,Mx,a
E6C9 C6                 store M6           (M6= a)
     02                 delete             My,Mx
E6CB C8                 store M8           (M8= Mx)
E6CC 02                 delete             My
E6CD C9                 store M9           (M9= My)
E6CE 02                 delete
E6CF E4                 recall M4          s
     20                 cos                cos s
     CC                 store MC           (MC= cos s)
E6D2 E4                 recall M4          cos s,s
     1F                 sin                cos s,sin s
     CD                 store MD           (MD= sin s)
E6D5 E8                 recall M8          cos s,sin s,Mx
E6D6 EE                 recall ME          cos s,sin s,Mx,Px
     03                 subtract           cos s,sin s,Mx-Px
E6D8 C8                 store M8           (M8= Mx-Px)
E6D9 04                 multiply           cos s,(Mx-Px)*sin s
E6DA 1B                 negate             cos s,-(Mx-Px)*sin s
E6DB 01                 exchange           -(Mx-Px)*sin s,cos s
     E9                 recall M9          -(Mx-Px)*sin s,cos s,My
     EF                 recall MF          -(Mx-Px)*sin s,cos s,My,Py
E6DE 03                 subtract           -(Mx-Px)*sin s,cos s,My-Py
E6DF C9                 store M9           (M9= My-Py)
E6E0 04                 multiply           -(Mx-Px)*sin s,(My-Py)*cos s
E6E1 0F                 add                u

E6E2 A1                 const one          u,1
E6E3 E8                 recall M8          u,1,Mx-Px
E6E4 EC                 recall MC          u,1,Mx-Px,cos s
     04                 multiply           u,1,(Mx-Px)*cos s
     E9                 recall M9          u,1,(Mx-Px)*cos s,My-Py
E6E7 ED                 recall MD          u,1,(Mx-Px)*cos s,My-Py,sin s
E6E8 04                 multiply           u,1,(Mx-Px)*cos s,(My-Py)*sin s
E6E9 0F                 add                u,1,v
E6EA 31                 duplicate          u,1,v,v
     04                 multiply           u,1,v^2
     E6                 recall M6          u,1,v^2,a
E6ED 31                 duplicate          u,1,v^2,a,a
     04                 multiply           u,1,v^2,a^2
     05                 divide             u,1,v^2/a^2
E6F0 03                 subtract           u,1-v^2/a^2
E6F1 28                 sqr                u,sqr(1-v^2/a^2)
     05                 divide             b
E6F3 C7                 store M7           (M7= b, the minor axis)
E6F4 02                 delete
E6F5 A0                 const zero         0
E6F6 C5                 store M5           (M5= t= 0)
E6F7 02                 delete
E6F8 38                 end calc           ;Disengage the calculator
E6F9 CD38DF             CALL CANCEL_MK     ;Cancel the marker cursor
E6FC A7                 AND  A             ;Reset carry to indicate ellipse
E6FD CD26E6   ELL_2     CALL ELL_Q         ;Draw the ellipse
E700 CDBF16             CALL SET_WORK      ;Clear workspace & restore calc mems
E703 C399E0             JP   CC_MOVE       ;Move the origin cursor and return

E706 C5       STK_REGS  PUSH BC
E707 D5                 PUSH DE
E708 E5                 PUSH HL
E709 0603               LD   B,#03
E70B E1       STRG_LOOP POP  HL            ;HL= next reg pair from stack
E70C C5                 PUSH BC            ;Stack B
E70D E5                 PUSH HL            ;Stack H
E70E 7D                 LD   A,L
E70F CD282D             CALL STACK_A       ;Stack one reg onto calc stack
E712 E1                 POP  HL
E713 7C                 LD   A,H
E714 CD282D             CALL STACK_A       ;Stack one reg onto calc stack
E717 C1                 POP  BC
E718 10F1               DJNZ STRG_LOOP
E71A C9                 RET

E71B C5       Q_ELLIPSE PUSH BC            ;Stack cursor coordinates
E71C ED5B0EDB           LD   DE,(ORIGIN+2) ;DE= Origin  cursor coords
E720 7A                 LD   A,D           ;A= Oy
E721 90                 SUB  B             ;A= difference in y coords
E722 3810               JR   C,QEL_2
E724 67                 LD   H,A           ;H= b, minor axis
E725 7B                 LD   A,E           ;A= Ox
E726 91                 SUB  C             ;A= difference in x coords
E727 3805               JR   C,QEL_1
E729 6F                 LD   L,A           ;L= a, major axis
E72A 3E01               LD   A,#01         ;A= quadrant number
E72C 1818               JR   QEL_5
E72E ED44     QEL_1     NEG
E730 6F                 LD   L,A           ;L= a, major axis
E731 AF                 XOR  A             ;A= 0, quadrant number
E732 180A               JR   QEL_3
E734 ED44     QEL_2     NEG
E736 67                 LD   H,A           ;H= b, minor axis
E737 7B                 LD   A,E           ;A= Ox
E738 91                 SUB  C             ;A= difference in x coords
E739 3806               JR   C,QEL_4
E73B 6F                 LD   L,A           ;L= a, major axis
E73C 3E02               LD   A,#02         ;A= quadrant number
E73E 4B       QEL_3     LD   C,E           ;BC= coords of ellipse centre
E73F 1806               JR   QEL_6
E741 ED44     QEL_4     NEG
E743 6F                 LD   L,A           ;L= a, major axis
E744 3E03               LD   A,#03         ;A= quadrant number
E746 42       QEL_5     LD   B,D           ;BC= coords of ellipse centre
E747 1600     QEL_6     LD   D,#00         ;D= 0, inclination of ellipse
E749 5F                 LD   E,A           ;E= quadrant number
E74A CDEADE             CALL ADJUST_B      ;Adjust coords to ROM convention
E74D CD06E7             CALL STK_REGS      ;Put regs onto calculator stack
E750 015000             LD   BC,#0050
E753 CD89E6             CALL CREATEMEM     ;Create sixteen calculator memories

E756 EF                 RST  #28           ;Engage the calculator
                                           a,b,q,0,Px,Py
E757 CF                 store MF           (MF= Py)
E758 02                 delete             a,b,q,0,Px
E759 CE                 store ME           (ME= Px)
     02                 delete             a,b,q,0
E75B C4                 store M4           (M4= s= 0; inclination of ellipse)
     CD                 store MD           (MD= sin s= 0)
     02                 delete             a,b,q
E75E A1                 const one          a,b,q,1
E75F CC                 store MC           (MC= cos s= 1)
     03                 subtract           a,b,q-1
     A3                 const pi/2         a,b,q-1,pi/2
E762 04                 multiply           a,b,(q-1)*pi/2
E763 C5                 store M5           (M5= t= angle corresponding 
                                            to start of curve
E764 02                 delete             a,b
E765 C7                 store M7           (M7= b)
E766 02                 delete             a
E767 C6                 store M6           (M6= a)
     02                 delete
E769 38                 end calc           ;Disengage the calculator
E76A 37                 SCF                ;Set carry to indicate
                                           ;quarter ellipse only
E76B C3FDE6             JP   ELL_2         ;Draw curve and finish off

E76E 7C       ATTR_ADDR LD   A,H           ;A= high part of pixel address
E76F 0F                 RRCA
E770 0F                 RRCA
E771 0F                 RRCA
E772 E603               AND  #03           ;A= 00, 01 or 2, according to which
                                           ;third of the screen the pixel is in
E774 F658               OR   #58
E776 67                 LD   H,A           ;HL= attribute address
E777 C9                 RET

;[The CPs at E77E/E786/E790 used different addresses for OLD_COLOUR]
;[(IX+8/IX+8/IX+6 respectively). All references in the next part   ]
;[use IX+8 (DB48), so I've changed E790 accordingly.           JimG]

E778 0A      COL_TEST   LD   A,(BC)        ;A= attribute byte from screen
E779 1F                 RRA
E77A 1F                 RRA
E77B 1F                 RRA
E77C E607               AND  #07           ;A= paper colour
E77E DDBE08             CP   (OLD_COLOUR)
E781 0A                 LD   A,(BC)        ;A= attribute byte from screen
E782 280A               JR   Z,COLTPAPER   ;Jump if paper colour matches search
                                           ;colour
E784 E607               AND  #07           ;A= ink colour
E786 DDBE08             CP   (OLD_COLOUR)
E789 2011               JR   NZ,COLT_NO    ;Jump if neither paper nor ink
                                           ;colour matches search
E78B 37                 SCF                ;Carry flag set (one match found)
E78C 9F                 SBC  A,A           ;Zero flag reset; A= FF (ink)
E78D C9                 RET
E78E E607     COLTPAPER AND  #07           ;A= ink colour
E790 DDBE08             CP   (OLD_COLOUR)
E793 2803               JR   Z,COLT_BOTH   ;Jump if both paper and ink match
                                           ;search
E795 AF                 XOR  A             ;Zero flag set; A= 00 (paper)
E796 37                 SCF                ;Carry flag set (one match found)
E797 C9                 RET
E798 3EFF     COLT_BOTH LD   A,#FF
E79A A7                 AND  A             ;Carry and zero flags both reset,
E79B C9                 RET                ;indicating paper and ink both match
E79C AF       COLT_NO   XOR  A             ;Zero flag set; Carry flag reset;
E79D C9                 RET                ;A= 00, indicating no match found

E79E E5       SR_PTRS   PUSH HL            ;Stack screen byte address
E79F CD6EE7             CALL ATTR_ADDR     ;HL= attribute byte address
E7A2 44                 LD   B,H
E7A3 4D                 LD   C,L           ;BC= attribute byte address
E7A4 E1                 POP  HL            ;HL= screen byte address
E7A5 54                 LD   D,H
E7A6 5D                 LD   E,L
E7A7 CBFA               SET  7,D           ;DE= SCR2 byte address
E7A9 C9                 RET

E7AA A7       SCAN_ROW  AND  A             ;Reset carry signals "Not a known
                                           ;interior point"
E7AB 08       SR_LOOP_1 EX   AF,AF'        ;Store in F'
E7AC 1A                 LD   A,(DE)        ;A= byte from SCR2
E7AD A7                 AND  A
E7AE 2850               JR   Z,SR_NEXT     ;Jump if there are no known interior
                                           ;points within this byte
E7B0 FEFF     SR_LOOP_2 CP   #FF
E7B2 37                 SCF
E7B3 284A               JR   Z,SR_NEXT_1   ;Jump if all eight pixels are already
                                           ;known to be interior
E7B5 CD78E7             CALL COL_TEST      ;Search attribute byte for interior
                                           ;colour
E7B8 3804               JR   C,SR_1MATCH   ;Jump if one match found
E7BA 2005               JR   NZ,SRALLBITS  ;Jump if paper and ink both match
E7BC 1841               JR   SR_NEXT_1     ;Otherwise jump with no match
E7BE BE       SR_1MATCH CP   (HL)
E7BF 2004               JR   NZ,SR_SCAN    ;Jump unless all eight bits are the
                                           ;required colour
E7C1 37       SRALLBITS SCF                ;Indicates "Known interior point"
E7C2 9F                 SBC  A,A           ;A= FF (ie. all bits set)
E7C3 182A               JR   SR_STORE      ;Jump to store FF
E7C5 C5       SR_SCAN   PUSH BC            ;Stack attribute byte pointer 
E7C6 0608               LD   B,#08         ;B= number of bits in a byte
E7C8 AE                 XOR  (HL)
E7C9 4F                 LD   C,A           ;C= byte from screen, with each bit
                                           ;reset for a known interior point,
                                           ;and set otherwise
E7CA 08                 EX   AF,AF'        ;Carry indicates whether or not last
                                           ;pixel was a known interior point
E7CB 1A                 LD   A,(DE)        ;A= byte from SCR2
E7CC DDCB006E           BIT  5,(JFLAGS)
E7D0 200F               JR   NZ,SR_SCAN_B  ;Jump if scanning from right to left
E7D2 3006     SR_SCAN_A JR   NC,SR_NBIT_A  ;Jump unless last pixel was a known
                                           ;interior point
E7D4 CB79               BIT  7,C
E7D6 2002               JR   NZ,SR_NBIT_A  ;Jump unless pixel is required colour
E7D8 F680               OR   #80           ;Set current pixel to show that it
                                           ;is a known interior point
E7DA CB01     SR_NBIT_A RLC  C             ;Get next bit into bit 7
E7DC 07                 RLCA               ;Move new bit into bit 0, and
                                           ;reassign carry flag accordingly
E7DD 10F3               DJNZ SR_SCAN_A     ;Repeat for all 8 bits
E7DF 180D               JR   SR_NEW
E7E1 3006     SR_SCAN_B JR   NC,SR_NBIT_B  ;Jump unless last pixel was a
                                           ;known interior point
E7E3 CB41               BIT  0,C
E7E5 2002               JR   NZ,SR_NBIT_B  ;Jump unless pixel is required colour
E7E7 F601               OR   #01           ;Set current pixel to show that it
                                           ;is a known interior point
E7E9 CB09     SR_NBIT_B RRC  C             ;Get next bit into bit 0
E7EB 0F                 RRCA               ;Move next bit into bit 7, and
                                           ;reassign carry flag accordingly
E7EC 10F3               DJNZ SR_SCAN_B     ;Repeat for all 8 bits
E7EE C1       SR_NEW    POP  BC            ;Restore attribute pointer
E7EF F5       SR_STORE  PUSH AF            ;Stack carry flag
E7F0 C5                 PUSH BC            ;Stack attribute pointer
E7F1 4F                 LD   C,A           ;C= new value to store in SCR2
E7F2 1A                 LD   A,(DE)        ;A= old value from SCR2
E7F3 2F                 CPL
E7F4 A1                 AND  C
E7F5 2804               JR   Z,SR_OLD      ;Jump unless at least one pixel is a
                                           ;newly discovered interior point
E7F7 DDCB00F6           SET  6,(JFLAGS)    ;Signal "Not finished yet"
E7FB 79       SR_OLD    LD   A,C
E7FC 12                 LD   (DE),A        ;Store new value in SCR2
E7FD C1                 POP  BC            ;Restore attribute pointer
E7FE F1                 POP  AF            ;Restore carry flag
E7FF 08       SR_NEXT_1 EX   AF,AF'        ;Store carry flag
E800 7D       SR_NEXT   LD   A,L
E801 E61F               AND  #1F           ;A= column number of char square
E803 DDCB006E           BIT  5,(JFLAGS)
E807 2008               JR   NZ,SR_DEC     ;Jump if scanning from right to left
E809 FE1F               CP   #1F
E80B C8                 RET  Z             ;Return if at right-hand edge of row
E80C 03                 INC  BC            ;Increment attribute pointer
E80D 13                 INC  DE            ;Increment SCR2 pointer
E80E 23                 INC  HL            ;Increment screen pointer
E80F 1805               JR   SR_CONT
E811 A7       SR_DEC    AND  A
E812 C8                 RET  Z             ;Return if at left-hand edge of row
E813 0B                 DEC  BC            ;Decrement attribute pointer
E814 1B                 DEC  DE            ;Decrement SCR2 pointer
E815 2B                 DEC  HL            ;Decrement screen pointer
E816 08       SR_CONT   EX   AF,AF'        ;Retrieve carry flag
E817 3092               JR   NC,SR_LOOP_1  ;Jump unless last point was known
                                           ;to be interior
E819 08                 EX   AF,AF'        ;Store carry flag again
E81A 1A                 LD   A,(DE)        ;A= next byte from SCR2
E81B 1893               JR   SR_LOOP_2

E81D 01800D   TM_POP    LD   BC,#0D80      ;BC= half number of bytes in SCR2
E820 2100DB             LD   HL,#DB00      ;HL point to the first byte beyond
                                           ;this area
E823 D1       TMP_LOOP  POP  DE            ;Get next two bytes from stack
E824 2B                 DEC  HL
E825 72                 LD   (HL),D
E826 2B                 DEC  HL
E827 73                 LD   (HL),E        ;Store next two bytes in SCR2
E828 0B                 DEC  BC
E829 78                 LD   A,B
E82A B1                 OR   C
E82B 20F6               JR   NZ,TMP_LOOP   ;Repeat for all bytes
E82D C9                 RET

E82E 2A655C   TEST_MEM  LD   HL,(STKEND)
E831 09                 ADD  HL,BC
E832 380A               JR   C,TM_NOT      ;Jump if not enough memory
E834 01501B             LD   BC,#1B50
E837 09                 ADD  HL,BC         ;Allow 1B50 bytes for SCR2 and
                                           ;machine stack
E838 3804               JR   C,TM_NOT      ;Jump if not enough memory
E83A ED72               SBC  HL,SP         ;Allow for position of machine stack
E83C 381E               JR   C,TM_PUSH     ;Jump if enough memory available
E83E DDCB0166 TM_NOT    BIT  4,(JFLAGS hi)
E842 2813               JR   Z,TM_?        ;Jump if screen memory not being used
E844 2151E8             LD   HL,TM_ESC     ;Load HL with "ESCAPE" address
E847 E5                 PUSH HL
E848 CDCCDC             CALL MESSAGE
E84B 03                 DEFB #03           ;Print message "WARNING Screen Memory
                                           ;Wipe" and await input
E84C E1                 POP  HL            ;Delete ESCAPE address
E84D FE59               CP   "Y"
E84F 2802               JR   Z,TM_WIPE     ;Jump if reply was "Y"
E851 F1       TM_ESC    POP  AF            ;Delete return address into subrt
E852 C9                 RET                ;Return to main loop
E853 DDCB01A6 TM_WIPE   RES  4,(JFLAGS hi) ;Signal "Screen memory not in use"
E857 DDCB01EE TM_?      SET  5,(JFLAGS hi) ;Signal "SCR2 has been corrupted"
E85B C9                 RET                ;Return to carry out procedure
E85C E1       TM_PUSH   POP  HL            ;HL= return address
E85D D9                 EXX                ;HL'= return address
E85E 01800D             LD   BC,#0D80      ;BC= half number of bytes in SCR2
E861 2100C0             LD   HL,#C000      ;HL points to first byte of SCR2
E864 5E       TMP_LOOP2 LD   E,(HL)
E865 23                 INC  HL
E866 56                 LD   D,(HL)        ;Get next two bytes from SCR2
E867 23                 INC  HL
E868 D5                 PUSH DE            ;Store on machine stack
E869 0B                 DEC  BC
E86A 78                 LD   A,B
E86B B1                 OR   C
E86C 20F6               JR   NZ,TMP_LOOP2
E86E 211DE8             LD   HL,TM_POP
E871 E5                 PUSH HL            ;Force future return into TM_POP
E872 D9                 EXX                ;HL= true return address
E873 E9                 JP   (HL)          ;Return to carry out procedure

E874 DDCB00FE PAINT     SET  7,(JFLAGS)    ;Signal "Now doing PAINT"
E878 CDCCDC             CALL MESSAGE
E87B 02                 DEFB #02           ;Input required paint colour
E87C 1807               JR   PAINTFILL

E87E DDCB00BE FILL      RES  7,(JFLAGS)    ;Signal "Now doing FILL"
E882 3A8D5C             LD   A,(ATTR_P)    ;A= current attribute byte
E885 E607     PAINTFILL AND  #07           ;A= required paint colour
E887 3249DB             LD   (NEW_COLOUR),A;Store paint colour
E88A 012000             LD   BC,#0020
E88D CD2EE8             CALL TEST_MEM      ;Store SCR2 if there is enough memory
E890 2100C0             LD   HL,#C000      ;Point HL to first  byte of SCR2
E893 1101C0             LD   DE,#C001      ;Point HL to second byte of SCR2
E896 01FF17             LD   BC,#17FF      ;BC= number of bytes in screen less 1
E899 3600               LD   (HL),#00      ;Clear first byte
E89B EDB0               LDIR               ;Clear remaining bytes
E89D 3A16DB             LD   A,(CURSOR+2)  ;A= pixel column number of cursor
E8A0 E607               AND  #07
E8A2 47                 LD   B,A
E8A3 04                 INC  B             ;B= position within byte of cursor
E8A4 3E01               LD   A,#01
E8A6 0F       PF_ALIGN  RRCA
E8A7 10FD               DJNZ PF_ALIGN      ;Align set bit to correct pos in A
E8A9 2A14DB             LD   HL,(CURSOR)   ;HL= address of screen byte
                                           ;containing cursor
E8AC F5                 PUSH AF
E8AD CD9EE7             CALL SR_PTRS       ;BC points to corresponding attr byte
                                           ;DE points to corresponding SCR2 byte
E8B0 F1                 POP  AF
E8B1 12                 LD   (DE),A        ;Set one pixel at cursor position,
                                           ;indicating a known interior point
E8B2 A6                 AND  (HL)
E8B3 0A                 LD   A,(BC)        ;A= attribute byte at cursor position
E8B4 2003               JR   NZ,PF_OLDCOL  ;Jump if cursor position is INKed
E8B6 0F                 RRCA
E8B7 0F                 RRCA
E8B8 0F                 RRCA
E8B9 E607     PF_OLDCOL AND  #07           ;A= colour of pixel at cursor pos
E8BB 3248DB             LD   (OLD_COLOUR),A;Store as the "old" interior colour
E8BE DDBE09             CP   (NEW_COLOUR)
E8C1 2005               JR   NZ,PF_BEGIN   ;Jump unless old colour same as new
E8C3 DDCB007E           BIT  7,(JFLAGS)
E8C7 C0                 RET  NZ            ;Return if doing PAINT
E8C8 DDCB00F6 PF_BEGIN  SET  6,(JFLAGS)    ;Signal "Not finished yet"
E8CC DDCB00A6           RES  4,(JFLAGS)    ;Signal "Scanning from top to bottom"
E8D0 DDCB00AE PF_LOOP   RES  5,(JFLAGS)    ;Signal "Scanning from left to right"
E8D4 CDAAE7             CALL SCAN_ROW      ;Scan row left to right
E8D7 DDCB00EE           SET  5,(JFLAGS)    ;Signal "Scanning from right to left"
E8DB CDAAE7             CALL SCAN_ROW      ;Scan row from right to left
E8DE DDCB0066           BIT  4,(JFLAGS)
E8E2 7C                 LD   A,H
E8E3 2009               JR   NZ,PFCHK_TOP  ;Jump if scanning from bottom to top
E8E5 FE57               CP   #57
E8E7 200D               JR   NZ,PF_CONT
E8E9 7D                 LD   A,L
E8EA FEA0               CP   #A0
E8EC 1806               JR   PFCHK_BOU
E8EE FE40     PFCHK_TOP CP   #40
E8F0 2004               JR   NZ,PF_CONT
E8F2 7D                 LD   A,L

E8F3 A7                 AND  A             ;Jump to change direction if at top
E8F4 285F     PFCHK_BOU JR   Z,PF_CHANGE   ;or bottom of screen
E8F6 C5                 PUSH BC            ;Stack attribute pointer
E8F7 D5                 PUSH DE            ;Stack SCR2 pointer
E8F8 E5                 PUSH HL            ;Stack screen pointer
E8F9 A7                 AND  A             ;Reset carry
E8FA 08                 EX   AF,AF'        ;Store reset carry in F' to signal
                                           ;"No new pixels marked"
E8FB D5                 PUSH DE
E8FC D9                 EXX
E8FD E1                 POP  HL
E8FE D9                 EXX                ;HL'= SCR2 pointer
E8FF 7C                 LD   A,H
E900 17                 RLA
E901 17                 RLA
E902 17                 RLA
E903 AC                 XOR  H
E904 E6C0               AND  #C0
E906 AC                 XOR  H
E907 67                 LD   H,A
E908 7D                 LD   A,L
E909 1F                 RRA
E90A 1F                 RRA
E90B AC                 XOR  H
E90C E638               AND  #38
E90E AC                 XOR  H
E90F 47                 LD   B,A           ;B= row number of current row
E910 DDCB0066           BIT  4,(JFLAGS)
E914 2002               JR   NZ,PF_1       ;Jump if scanning from bottom to top
E916 04                 INC  B
E917 04                 INC  B
E918 05       PF_1      DEC  B             ;B= row number of next row to scan
E919 0E00               LD   C,#00
E91B CD41DD             CALL PIX_ADDR      ;HL= address of new row
E91E CD9EE7             CALL SR_PTRS       ;BC= address of new attributes row
                                           ;DE= address of new SCR2 row
E921 C5                 PUSH BC            ;Stack attributes pointer
E922 D5                 PUSH DE            ;Stack SCR2 pointer
E923 E5                 PUSH HL            ;Stack screen pointer
E924 CD78E7   PF_LOOP_2 CALL COL_TEST      ;Test colour match for this square
E927 3004               JR   NC,PF_2       ;Jump unless just one colour matches
E929 2F                 CPL                ;A= 00(INK match) or FF(PAPER match)

E92A AE                 XOR  (HL)          ;A= next byte from screen, with each
                                           ;bit set if the colour matches the
                                           ;interior colour, reset otherwise
E92B 1802               JR   PF_3
E92D 280C     PF_2      JR   Z,PF_NEXT     ;Jump if the attribute does not
                                           ;contain the interior colour
E92F D9       PF_3      EXX
E930 A6                 AND  (HL)          ;Each bit will remain set only if
E931 D9                 EXX                ;the corresponding pixel is (a) the
                                           ;right colour, and (b) directly above
                                           ;(or below) a known interior pixel
E932 EB                 EX   DE,HL
E933 B6                 OR   (HL)          ;Also include any known interior
                                           ;pixel from this row
E934 77                 LD   (HL),A        ;Store in SCR2
E935 EB                 EX   DE,HL
E936 A7                 AND  A
E937 2802               JR   Z,PF_NEXT     ;Jump unless at least one pixel in
                                           ;this byte is known to be interior
E939 37                 SCF
E93A 08                 EX   AF,AF'        ;Store set carry to signal "At least
                                           ;one pixel on this row is interior"
E93B 03       PF_NEXT   INC  BC            ;Increment attributes pointer
E93C 13                 INC  DE            ;Increment SCR2 pointer
E93D 23                 INC  HL            ;Increment screen pointer
E93E D9                 EXX
E93F 23                 INC  HL            ;Increment SCR2 pointer to row above
E940 D9                 EXX                ;(or below)
E941 7D                 LD   A,L
E942 E61F               AND  #1F
E944 20DE               JR   NZ,PF_LOOP_2  ;Jump back unless at end of row
E946 E1                 POP  HL            ;Screen pointer now at start of row
E947 D1                 POP  DE            ;SCR2 pointer now at start of row
E948 C1                 POP  BC            ;Attribute pointer at start of row
E949 08                 EX   AF,AF'        ;Retrieve carry flag
E94A 3006               JR   NC,PFCHANGE1  ;Jump if there were no known interior
                                           ;points on this row

E94C F1                 POP  AF
E94D F1                 POP  AF
E94E F1                 POP  AF
E94F C3D0E8   PF_JUMP   JP   PF_LOOP       ;Jump to scan next row
E952 E1       PFCHANGE1 POP  HL            ;Screen pointer now at start of
                                           ;previous row
E953 D1                 POP  DE            ;Same for SCR2 pointer
E954 C1                 POP  BC            ;and for attribute pointer
E955 3A40DB   PF_CHANGE LD   A,(JFLAGS)
E958 EE50               XOR  #50           ;Change scan direction flag and
E95A 3240DB             LD   (JFLAGS),A    ;"Finished yet?" flag
E95D CB77               BIT  6,A
E95F 28EE               JR   Z,PF_JUMP     ;Jump back unless finished
E961 010058             LD   BC,#5800      ;BC points to first attribute byte
E964 1100C0             LD   DE,#C000      ;DE points to first SCR2 byte
E967 210040             LD   HL,#4000      ;HL points to first screen byte
E96A 3A49DB             LD   A,(NEW_COLOUR);A= colour to paint
E96D 07                 RLCA
E96E 07                 RLCA
E96F 07                 RLCA
E970 3248DB             LD   (OLD_COLOUR),A;Store 8*colour
E973 E5       PF_SQLOOP PUSH HL            ;Stack screen pointer
E974 D5                 PUSH DE            ;Stack SCR2 pointer
E975 C5                 PUSH BC            ;Stack attribute pointer
E976 010008             LD   BC,#0800
E979 1A       PF_SQUARE LD   A,(DE)        ;A= next byte from SCR2
E97A A6                 AND  (HL)
E97B 2802               JR   Z,PF_P_EXT
E97D CBD9               SET  3,C           ;Set flag if you come across an
                                           ;INKed interior point
E97F 1A       PF_P_EXT  LD   A,(DE)
E980 2F                 CPL
E981 B6                 OR   (HL)
E982 3C                 INC  A
E983 2802               JR   Z,PF_I_EXT
E985 CBD1               SET  2,C           ;Set flag if you come across a
                                           ;PAPERed interior point
E987 1A       PF_I_EXT  LD   A,(DE)
E988 2F                 CPL
E989 A6                 AND  (HL)
E98A 2802               JR   Z,PF_P_INT
E98C CBC9               SET  1,C           ;Set flag if you come across an
                                           ;INKed exterior point
E98E 1A       PF_P_INT  LD   A,(DE)
E98F B6                 OR   (HL)
E990 3C                 INC  A
E991 2802               JR   Z,PF_I_INT
E993 CBC1               SET  0,C           ;Set flag if you come across a
                                           ;PAPERed exterior point
E995 14       PF_I_INT  INC  D             ;SCR2 pointer to next row
E996 24                 INC  H             ;Screen pointer to next row
E997 10E0               DJNZ PF_SQUARE     ;Repeat for all rows of char square
E999 0608               LD   B,#08
E99B 79                 LD   A,C
E99C D604               SUB  #04

E99E 385B               JR   C,PF_NXT_SQ   ;Jump if every pixel in the square
                                           ;is exterior
E9A0 DDCB007E           BIT  7,(JFLAGS)
E9A4 280A               JR   Z,PFSETLOOP   ;Jump if doing FILL
E9A6 A7                 AND  A
E9A7 2843               JR   Z,PF_ALL_PP   ;Jump if every pixel is a PAPERed
                                           ;interior point
E9A9 D602               SUB  #02
E9AB 2833               JR   Z,PF_CH_PP    ;Jump if this is a boundary square
                                           ;with paper interior, ink exterior
E9AD 3D                 DEC  A
E9AE 2009               JR   NZ,PF_A1      ;Jump unless the square contains an
                                           ;INK boundary separating two PAPER
                                           ;regions, one interior, one exterior
E9B0 15       PFSETLOOP DEC  D             ;SCR2 pointer to next row
E9B1 25                 DEC  H             ;Screen pointer to next row
E9B2 1A                 LD   A,(DE)
E9B3 B6                 OR   (HL)
E9B4 77                 LD   (HL),A        ;INK all interior pixels
E9B5 10F9               DJNZ PFSETLOOP     ;Repeat for whole character square
E9B7 1811               JR   PF_CH_INK
E9B9 3D       PF_A1     DEC  A
E9BA 200B               JR   NZ,PF_A2      ;Jump unless every pixel is INKed
                                           ;and interior
E9BC AF                 XOR  A
E9BD DDCB086E           BIT  5,(OLD_COLOUR)
E9C1 200C               JR   NZ,PFSET_INK  ;Jump if new colour is light
E9C3 3E38               LD   A,#38         ;Set paper colour to white
E9C5 1808               JR   PFSET_INK     ;Jump to change attribute byte
E9C7 3D       PF_A2     DEC  A
E9C8 200A               JR   NZ,PF_A3      ;Jump unless this is a boundary sqr
                                           ;with ink interior, paper exterior
E9CA C1       PF_CH_INK POP  BC
E9CB 0A                 LD   A,(BC)        ;A= attribute byte of current square
E9CC C5                 PUSH BC
E9CD E638               AND  #38           ;Isolate paper colour
E9CF DDB609   PFSET_INK OR   (NEW_COLOUR)  ;Change ink colour
E9D2 1824               JR   PFST_ATTR
E9D4 D602     PF_A3     SUB  #02
E9D6 200F               JR   NZ,PFCLRLOOP  ;Jump unless the square contains a
                                           ;PAPER boundary separating two INK
                                           ;regions, one interior, one exterior

E9D8 15       PRRESLOOP DEC  D             ;SCR2 pointer to next row
E9D9 25                 DEC  H             ;Screen pointer to next row
E9DA 1A                 LD   A,(DE)
E9DB 2F                 CPL
E9DC A6                 AND  (HL)
E9DD 77                 LD   (HL),A        ;PAPER all interior pixels
E9DE 10F8               DJNZ PRRESLOOP     ;Repeat for whole character square
E9E0 C1       PF_CH_PP  POP  BC
E9E1 0A                 LD   A,(BC)        ;A= attribute byte of current square
E9E2 C5                 PUSH BC
E9E3 E607               AND  #07           ;Isolate ink colour
E9E5 180E               JR   PF_SET_PP
E9E7 25       PFCLRLOOP DEC  H             ;Screen pointer to next row
E9E8 3600               LD   (HL),#00      ;PAPER every pixel
E9EA 10FB               DJNZ PFCLRLOOP     ;Repeat for whole character square
E9EC AF       PF_ALL_PP XOR  A             ;A= 00 (ink black)
E9ED DDCB0956           BIT  2,(NEW_COLOUR)
E9F1 2002               JR   NZ,PF_SET_PP  ;Jump if new colour is light
E9F3 3E07               LD   A,#07         ;Set ink colour to white
E9F5 DDB608   PF_SET_PP OR   (OLD_COLOUR)  ;Change paper colour to new colour
E9F8 C1       PFST_ATTR POP  BC
E9F9 02                 LD   (BC),A        ;Store new attribute byte
E9FA C5                 PUSH BC
E9FB C1       PF_NXT_SQ POP  BC            ;BC= attribute pointer
E9FC D1                 POP  DE            ;DE= SCR2 pointer
E9FD E1                 POP  HL            ;HL= screen pointer
E9FE 03                 INC  BC            ;Increment attribute pointer
E9FF 13                 INC  DE            ;Increment SCR2 pointer
EA00 23                 INC  HL            ;Increment screen pointer
EA01 7D                 LD   A,L
EA02 A7                 AND  A
EA03 2009               JR   NZ,PF_J2      ;Jump unless at end of "third"
                                           ;of screen
EA05 7A                 LD   A,D
EA06 C607               ADD  A,#07
EA08 57                 LD   D,A           ;DE points to next square
EA09 E67F               AND  #7F
EA0B 67                 LD   H,A           ;HL points to next square
EA0C FE58               CP   #58
EA0E C273E9   PF_J2     JP   NZ,PF_SQLOOP  ;Jump back unless at end of screen
EA11 C9                 RET

EA12 3E40     CURS_TYPE LD   A,#40
EA14 C32ADF             JP   CT_H
